

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.Point;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Enumeration;
import java.util.List;
import java.util.Properties;
import java.util.TreeMap;

import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.JSplitPane;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.KeyStroke;
import javax.swing.border.BevelBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.table.DefaultTableColumnModel;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;

import org.jdesktop.swingx.JXTable.GenericEditor;
import org.jdesktop.swingx.JXTreeTable;

import jp.hozo.core.Concept;
import jp.hozo.core.HozoObject;
import jp.hozo.core.Ontology;
import jp.hozo.core.P_Operator;
import jp.hozo.core.RConceptRelation;
import jp.hozo.core.R_Operator;
import jp.hozo.core.RoleHolder;
import jp.hozo.core.Slot;
import jp.hozo.core.SpeciesConcept;
import jp.hozo.core.WholeConcept;
import jp.hozo.core.util.FileUtility;
import jp.hozo.corex.HZOntology;
import jp.hozo.corex.util.HZFileUtility;
import jp.hozo.oat.*;
import jp.hozo.oat.ConceptTreePanel.ConceptTree;
import jp.hozo.reasoner.SearchReport;
import jp.hozo.reasoner.SearchResult;
import jp.hozo.test.TestTimer;


/**
 * 
 * f[^Lqp萫lϊc[
 * 
 */
public class EQ2EAVTool {

	// ݒ
	//private static String FRAME_TITLE = "Hozo.OAT Sample";
	private static String FRAME_TITLE = "EQ2EAV Tool";
	private static String openFolderPath = "./data3";
	private static String STATSU_BAR_INITIALIZE_STRING = "Ready.";


	// \镔i
	private JFrame frame = new JFrame(FRAME_TITLE);
	private ConceptTreePanel ontTree;
	private MyOntoSearchPanel ontSearchPanel;
	private MyOntoGraphPanel graphPanel;
	private JPanel inheritPanel;
	private JLabel statusBar = new JLabel(STATSU_BAR_INITIALIZE_STRING);

	// ̑IuWFNg
	private HZOntology ont;

	// ۑIgW[
	private HZOntology saveOnt;

	private int treeType = ConceptTreePanel.TREE_TYPE_BOTH;
	
//	private boolean slotVisible = true;
	private boolean slotVisible = false;		// ftH[g\
	
	// c[e[uݒŎw肵Entityl
	private String entityValue;
	// c[e[uݒŎw肵Attributel
	private String attributeValue;
	// c[e[uݒŎw肵Valuel
	private String value;
	// c[e[uݒŎw肵EVAl
	private String evaForm;
	// e[uJXgieq́j
	private List<Object> columnArray;
	// e[uJziSāj
	private String[] columnNames;
	
	private EAVSetupFrame esf;
	private TreeTableFrame ttf;
	private TableColumnModel tcm;
	private MetadataTableFrame mtf;
	
	private boolean isShortCut;
	private boolean isValueMasked;
	private int size;
	private boolean replaceLineToColumn;
	private boolean removeEmptyColumn;
	
	/**
	 * C
	 */
	public static void main(String[] args) {
		if (args != null && args.length > 0) {
			new EQ2EAVTool(new File(args[0]), true);
		} else {
			new EQ2EAVTool(null, true);
		}
	}

	/**
	 * RXgN^
	 */
	public EQ2EAVTool(File file, boolean visible) {
		// j[̐ݒ
		this.setMenu();
		// e\pi̐ݒ
		this.setContents();
		// t@CǍ
		if (file != null) {
			loadOntology(file);
		}
	}

	/**
	 * j[ݒ肷
	 */
	private void setMenu() {

		// j[o[̍쐬
		JMenuBar menuBar = new JMenuBar();
		this.frame.setJMenuBar(menuBar);

		// j[ ("File") ̍쐬
		JMenu fileMenu = new JMenu("File");
		menuBar.add(fileMenu);

		// j[ACe ("Open") ̍쐬
		JMenuItem openMenuItem = new JMenuItem("open ...");
		openMenuItem.setAccelerator(
			KeyStroke.getKeyStroke(KeyEvent.VK_N, InputEvent.CTRL_MASK));
		openMenuItem.addActionListener(
			new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					fileOpen();
				}
			}
		);
		fileMenu.add(openMenuItem);
		// Zp[^̑}
		fileMenu.addSeparator();

		// j[ACe ("Convert") ̍쐬
		JMenuItem convertMenuItem = new JMenuItem("convert EQ to EAV ...");
		convertMenuItem.setAccelerator(
			KeyStroke.getKeyStroke(KeyEvent.VK_E, InputEvent.CTRL_MASK));
		convertMenuItem.addActionListener(
			new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					FolderPanel folderPanel = new FolderPanel();
					folderPanel.setVisible(true);
				}
			}
		);
		fileMenu.add(convertMenuItem);

		// Zp[^̑}
		fileMenu.addSeparator();
		
		// j[ACe ("TreeTable") ̍쐬
		JMenuItem treeTableMenuItem = new JMenuItem("display E_A_V in a Table ...");
		treeTableMenuItem.addActionListener(
			new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					setTreeTableConf();
				}
			}
		);
		fileMenu.add(treeTableMenuItem);
		
		// Zp[^̑}
		fileMenu.addSeparator();
		
		// j[ACe ("Save") ̍쐬
		JMenuItem saveMenuItem = new JMenuItem("save ...");
		saveMenuItem.setAccelerator(
			KeyStroke.getKeyStroke(KeyEvent.VK_S, InputEvent.CTRL_MASK));
		saveMenuItem.addActionListener(
			new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					saveOtn();
				}
			}
		);
		fileMenu.add(saveMenuItem);

		// Zp[^̑}
		fileMenu.addSeparator();

		// j[ACe ("Exit") ̍쐬
		JMenuItem exitMenuItem = new JMenuItem("exit");
		exitMenuItem.setAccelerator(
				KeyStroke.getKeyStroke(KeyEvent.VK_C, InputEvent.CTRL_MASK));
		exitMenuItem.addActionListener(
			new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					System.exit(0);
				}
			}
		);
		fileMenu.add(exitMenuItem);

		// j[ ("View") ̍쐬
		JMenu viewMenu = new JMenu("View");
		menuBar.add(viewMenu);

		// j[ACe ("Tree") ̍쐬
		JMenu treeMenuItem = new JMenu("Tree");

		JMenuItem treeBoth = new JRadioButtonMenuItem("Both"); 
		treeBoth.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				setTreeType(ConceptTreePanel.TREE_TYPE_BOTH);
				updateTree();
			}
		});
		JMenuItem treeWhole = new JRadioButtonMenuItem("Whole Concept Only"); 
		treeWhole.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				setTreeType(ConceptTreePanel.TREE_TYPE_WHOLE_ONLY);
				updateTree();
			}
		});
		JMenuItem treeRelation = new JRadioButtonMenuItem("Relation Only"); 
		treeRelation.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				setTreeType(ConceptTreePanel.TREE_TYPE_RELATION_ONLY);
				updateTree();
			}
		});
		
		ButtonGroup bg = new ButtonGroup();
		bg.add(treeBoth);
		bg.add(treeWhole);
		bg.add(treeRelation);

		treeBoth.setSelected(true); // default

		viewMenu.add(treeMenuItem);

		treeMenuItem.add(treeBoth);
		treeMenuItem.add(treeWhole);
		treeMenuItem.add(treeRelation);	

		// j[ACe ("Slot") ̍쐬
		JMenu slotMenuItem = new JMenu("Slot");

		JMenuItem slotVisibleMenuItem = new JRadioButtonMenuItem("Show"); 
		slotVisibleMenuItem.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				slotVisible = true;
				updateTree();
			}
		});
		JMenuItem slotInvisibleMenuItem = new JRadioButtonMenuItem("Hide"); 
		slotInvisibleMenuItem.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				slotVisible = false;
				updateTree();
			}
		});

		ButtonGroup bg2 = new ButtonGroup();
		bg2.add(slotVisibleMenuItem);
		bg2.add(slotInvisibleMenuItem);

//		slotVisibleMenuItem.setSelected(true); // default
		if (slotVisible) {
			slotVisibleMenuItem.setSelected(true);
			slotInvisibleMenuItem.setSelected(false);
		} else {
			slotVisibleMenuItem.setSelected(false);
			slotInvisibleMenuItem.setSelected(true);
		}

		viewMenu.add(slotMenuItem);

		slotMenuItem.add(slotVisibleMenuItem);
		slotMenuItem.add(slotInvisibleMenuItem);

		
	}

	private void setTreeType(int type){
		treeType = type;
		ontSearchPanel.setScopeTreeType(type);

	}
	
	/**
	 * ͐VK쐬̏Ɠꂵ
	 * @param type
	 * @return
	 */
	private ConceptTreePanel updateTree(){
		ontTree = new MyOntoTree(this, true, treeType, slotVisible);
		if (frame != null){
			frame.repaint();
		}
		if (tabbedPane != null){
			while(tabbedPane.getTabCount() > 0){
				tabbedPane.removeTabAt(0);
			}
			tabbedPane.addTab("Tree\", ontTree);
			// ʂɔf
			this.ontTree.setTree(this.ont);
			tabbedPane.addTab("", searchScrollPane);
		}
		
		return ontTree;
	}

	private JTabbedPane tabbedPane;
	
	private JScrollPane searchScrollPane;

	/**
	 * e\piݒ肷
	 */
	private void setContents() {

		// XXX IA`FbN{bNXtc[̕\ݒ
		// yC̍쐬 (c[ƌpl)
//		this.ontTree = new MyOntoTree(this);
		this.ontTree = updateTree();// new MyOntoTree(this, true);
//		this.ontSearchPanel = new MyOntoSearchPanel(this, this.frame, ConceptSearchPanel.SearchTabOption.BOTH);
		this.ontSearchPanel = new MyOntoSearchPanel(this, this.frame, ConceptSearchPanel.SearchTabOption.BOTH, false, true);
		// TODO: SearchTabOption ́Aݒt@Cǂݍ݁H

		// yC^u
		tabbedPane = new JTabbedPane();
		searchScrollPane = new JScrollPane(this.ontSearchPanel);
		ontTree = updateTree();
/*
		tabbedPane.addTab("Tree\", this.ontTree);
		tabbedPane.addTab("",  searchScrollPane);
*/

		// EyC̍쐬 (OtBbNpl)
		this.graphPanel = new MyOntoGraphPanel(this);
		graphPanel.addUpdateListener(new ConceptGraphPanelUpdateListener() {
			
			@Override
			public void updated(ConceptGraphPanel panel) {
				frame.validate();
				frame.repaint();
			}
		});
		JPanel graphBase = new JPanel();
		graphBase.setLayout(new GridLayout(1,1));
		graphBase.add(graphPanel);
		JScrollPane scrollPane = new JScrollPane(graphBase);
//		JScrollPane scrollPane = new JScrollPane(graphPanel);
		scrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);

		JPanel rightPanel = new JPanel();
		rightPanel.setLayout(new BorderLayout());
		rightPanel.add(BorderLayout.CENTER, scrollPane);
		
		inheritPanel = new InheritPanel();
		rightPanel.add(BorderLayout.NORTH, inheritPanel);
		
		
		// Xvb^
		JSplitPane splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, tabbedPane, rightPanel);
		splitPane.setOneTouchExpandable(true);
		splitPane.setDividerLocation(310);
		splitPane.setAutoscrolls(true);
//		splitPane.setPreferredSize(new Dimension(200, 200));
		this.frame.add(splitPane);

		// Xe[^Xo[̓\t
		this.frame.add(statusBar, BorderLayout.SOUTH);

		// t[̕\ݒ
		this.frame.setBounds(100, 100, 800, 800);
		this.frame.setVisible(true);
		this.frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		//this.frame.setResizable(false);
	}

	/**
	 * TO`Cxg
	 */
	private void paintGraphPanel(Concept con) {

		this.graphPanel.setConcept(con);
		this.frame.repaint();
	}
	/**
	 * TO`Cxg
	 * @param slot IXbgw
	 */
	private void paintGraphPanel(Concept con, Slot slot) {
		this.graphPanel.setConcept(con);
		this.graphPanel.setSelectedSlot(slot);
		this.frame.repaint();
	}

	/**
	 * TO`Cxg
	 */
	private void setSearchResultCount(int resultCount) {

		this.statusBar.setText(String.format("search Results = [%d]", resultCount));
	}

	/**
	 * t@CI[vCxg
	 */
	public void fileOpen() {

		// t@CI_CAOĂяo
		JFileChooser fileChooser = new JFileChooser(openFolderPath);

		// t@CIʎ擾
		int result = fileChooser.showOpenDialog(frame);
		File loadFile = fileChooser.getSelectedFile();
		if (result == JFileChooser.CANCEL_OPTION || loadFile == null) {
			// LZA܂́At@CIȂ̂߉Ȃ
			return;
		}
		
//		// ΃pX̎擾
//		String fileName = loadFile.getAbsolutePath();
//
//		// IgW[[h
//		this.ont = new HZOntology();
//		this.ont.setSource(fileName);
//		System.out.println("Load Ontology File: " + fileName);
//		try {
//			ont.load();
//		} catch(Exception e) {
//			e.printStackTrace();
//			System.out.println("...Fault");
//		}
//		System.out.println("...Complete!");
//
//		// ʂɔf
//		this.ontTree.setTree(this.ont);
//		this.frame.setTitle(FRAME_TITLE + " - [ " + loadFile.getName() + " ]");
//		this.frame.repaint();
//
//		// plɔf
//		this.ontSearchPanel.setOntology(this.ont);
//		this.ontSearchPanel.setSimilarityThreshold(0.1);
//		// TODO: SimilarityThreshold ́Aݒt@Cǂݍ݁H
//		
//		this.ontSearchPanel.setScopeTreeType(treeType);	
		loadOntology(loadFile);
	}
	
	/**
	 * IgW[ǂݍ
	 * 
	 * @param loadFile
	 */
	private void loadOntology(File loadFile) {
		// ΃pX̎擾
		String fileName = loadFile.getAbsolutePath();
		
		// IgW[[h
		this.ont = new HZOntology();
		this.ont.setSource(fileName);
		System.out.println("Load Ontology File: " + fileName);
		try {
			ont.load();
		} catch(Exception e) {
			e.printStackTrace();
			System.out.println("...Fault");
		}
		System.out.println("...Complete!");

		// ʂɔf
		this.ontTree.setTree(this.ont);
		this.frame.setTitle(FRAME_TITLE + " - [ " + loadFile.getName() + " ]");
		this.frame.repaint();

		// plɔf
		this.ontSearchPanel.setOntology(this.ont);
		this.ontSearchPanel.setSimilarityThreshold(0.1);
		// TODO: SimilarityThreshold ́Aݒt@Cǂݍ݁H
		
		this.ontSearchPanel.setScopeTreeType(treeType);
	}
	
	/**
	 * ϊIgW[ۑ
	 */
	public void saveOtn() {
		// ϊIgW[t@Cۑ
		if (this.saveOnt == null || this.saveOnt.getSource() == null) {
			return;
		}
		try {
			if (this.saveOnt.getSource() != null) {
				if (this.saveOnt.getSource().endsWith(".ont")) {
					this.saveOnt.saveWithDependency(true);
				} else {
					this.saveOnt.save("UTF-8");
				}
			}
			System.out.println("t@Cu" + this.saveOnt.getSource() + "vŕۑ܂B");
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}
	}

	public String getEntityValue() {
		return entityValue;
	}

	public void setEntityValue(String entityValue) {
		this.entityValue = entityValue;
	}

	public String getAttributeValue() {
		return attributeValue;
	}

	public void setAttributeValue(String attributeValue) {
		this.attributeValue = attributeValue;
	}

	public String getValue() {
		return value;
	}

	public void setValue(String value) {
		this.value = value;
	}
	
	public String getEVAForm() {
		return evaForm;
	}

	public void setEVAForm(String value) {
		this.evaForm = value;
	}

	public List<Object> getColumnArray() {
		return columnArray;
	}

	public void setColumnArray(List<Object> objects) {
		this.columnArray = objects;
	}

	public String[] getColumnNames() {
		return columnNames;
	}

	public void setColumnNames(String[] columnNames) {
		this.columnNames = columnNames;
	}

	/**
	 * EAVc[e[u\
	 */
	public void setTreeTableConf() {
		if (ont== null) {
		    JOptionPane.showMessageDialog(this.frame, "IgW[t@CJĂB");
		    return;
		}

		//EAVSetupFrame esp = new EAVSetupFrame();
		if (esf == null) {
			esf = new EAVSetupFrame();	
		}
		esf.setAlwaysOnTop(true);
		esf.setVisible(true);
	}
	
	/**
	 * c[e[u쐬
	 */
	public void createTreeTable(boolean shortCut) {
		this.createTreeTable(shortCut, false);
	}
	public void createTreeTable(boolean shortCut, boolean isValueMasked) {
		this.createTreeTable(shortCut, isValueMasked, -1, false, false);
	}
	public void createTreeTable(boolean isShortCut, boolean isValueMasked, int size, boolean replaceLineToColumn, boolean removeEmptyColumn) {
		//TreeTablePanel ttp = new TreeTablePanel(shortCut);
		//TreeTableFrame ttp = new TreeTableFrame(shortCut, isValueMasked);
		if (ttf != null) {
			ttf.dispose();		// UA폜
		}
//		if (size > 0) {
//			ttp = new TreeTableFrame(shortCut, isValueMasked, size);
//		} else {
//			ttp = new TreeTableFrame(shortCut, isValueMasked);
//		}
		ttf = new TreeTableFrame(isShortCut, isValueMasked, size, replaceLineToColumn, removeEmptyColumn);
		ttf.setAlwaysOnTop(true);
		ttf.setVisible(true);
		
		this.isShortCut = isShortCut;
		this.isValueMasked = isValueMasked;
		this.size = size;
		this.replaceLineToColumn = replaceLineToColumn;
		this.removeEmptyColumn = removeEmptyColumn;
	}

	/**
	 * ^f[^e[u쐬
	 */
	public void createMetadataTable() {
		if (mtf != null) {
			mtf.dispose();		// UA폜
		}
		mtf = new MetadataTableFrame(this.isShortCut, this.isValueMasked, this.size, this.replaceLineToColumn, this.removeEmptyColumn);
		mtf.setAlwaysOnTop(true);
		mtf.setVisible(true);
	}
	
	/**
	 * tH_̈ꊇGNX|[g̑Ipl
	 */
	class FolderPanel extends JDialog {
		/**
		 *
		 */
		private static final long serialVersionUID = -9053507333356379516L;

		// Oݒ肵t@Cۑt@C
		private static final String PREV_INFO_FILE = "eq2eav.properties";
		private static final String PREV_OBO_FILE = "OBO_FILE";
		private static final String PREV_PATO_FILE = "PATO_FILE";
		private static final String PREV_REF_FILE = "EAV_FILE";
		private static final String PREV_ORGAN_FILE = "ORGAN_FILE";
		/* ϊʃt@Cw */
		private String RESULT_FILE_NAME = "result.txt";
		private int DEFAULT_PARSER = Ontology.SAX_PARSER;

		/**  */
		FolderPanel panel;
		/** */
		private File oboPath = null;
		/** */
		private File patoPath = null;
		/** */
		private File eavPath = null;
		/** */
		private String conceptLabel = null;
		
		/** Oݒۑt@C */
		File prevInfoFile = new File(PREV_INFO_FILE);

		/**
		 * RXgN^
		 */
		public FolderPanel() {

			super(frame, "convert EQ to EAV ...", true);
			final Container contentPane = getContentPane();
			
			// Oݒ肵t@CǍ
			final Properties tmpPath = new Properties();
			if (prevInfoFile.exists()) {
			    try {
			        InputStream inputStream = new FileInputStream(prevInfoFile);
			        tmpPath.load(inputStream);
			    } catch (IOException e) {
			    	e.printStackTrace();
			    }
			}

			final int width = 450;
			final int height = 270;
			final int x = frame.getX() + frame.getWidth() / 2 - width / 2;
			final int y = frame.getY() + frame.getHeight() / 2 - height / 2;
			setBounds(x, y, width, height);
			
			final JPanel mainPanel = new JPanel();
			contentPane.add(mainPanel, BorderLayout.NORTH);
			GridBagLayout layout = new GridBagLayout();
			mainPanel.setLayout(layout);
			GridBagConstraints gbc = new GridBagConstraints();

			JLabel oboLabel = new JLabel(" OBO file: ");
			gbc.gridx = 0;
			gbc.gridy = 0;
			gbc.weightx = 1.0d;
			gbc.anchor = GridBagConstraints.WEST;
			gbc.insets = new Insets(1, 5, 1, 5);
			layout.setConstraints(oboLabel, gbc);
			mainPanel.add(oboLabel);

			final JTextField oboFileName = new JTextField(60);
			oboFileName.setPreferredSize(new Dimension(200, 15));
			if (tmpPath.getProperty(PREV_OBO_FILE) != null && tmpPath.getProperty(PREV_OBO_FILE).length() > 0) {
				oboFileName.setText(tmpPath.getProperty(PREV_OBO_FILE));
				oboPath = new File(tmpPath.getProperty(PREV_OBO_FILE));
			}
		    gbc.gridx = 0;
		    gbc.gridy = 1;
		    gbc.fill = GridBagConstraints.HORIZONTAL;
		    layout.setConstraints(oboFileName, gbc);
			mainPanel.add(oboFileName);

			final JButton oboButton = new JButton("...");
			oboButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final ActionEvent e) {

					// tH_I_CAOĂяo
					JFileChooser fileChooser = new JFileChooser(openFolderPath);

					// tH_Iʎ擾
					int result = fileChooser.showOpenDialog(mainPanel);
					oboPath = fileChooser.getSelectedFile();
					if (result == JFileChooser.CANCEL_OPTION || oboPath == null) {
						// LZA܂́AtH_IȂ̂߉Ȃ
						return;
					}
					oboFileName.setText(oboPath.getAbsolutePath());
					tmpPath.setProperty(PREV_OBO_FILE, oboPath.getAbsolutePath());
				}
			});
		    gbc.gridx = 1;
		    gbc.gridy = 1;
			gbc.weightx = 0.1d;
		    gbc.fill = GridBagConstraints.NONE;
		    layout.setConstraints(oboButton, gbc);
			mainPanel.add(oboButton);

			JLabel patoLabe = new JLabel(" PATO2YAMATO file: ");
		    gbc.gridx = 0;
		    gbc.gridy = 2;
		    layout.setConstraints(patoLabe, gbc);
			mainPanel.add(patoLabe);

			final JTextField patoFileName = new JTextField(60);
		    gbc.fill = GridBagConstraints.HORIZONTAL;
			if (tmpPath.getProperty(PREV_PATO_FILE) != null && tmpPath.getProperty(PREV_PATO_FILE).length() > 0) {
				patoFileName.setText(tmpPath.getProperty(PREV_PATO_FILE));
				patoPath = new File(tmpPath.getProperty(PREV_PATO_FILE));
			}
		    gbc.gridx = 0;
		    gbc.gridy = 3;
		    layout.setConstraints(patoFileName, gbc);
			mainPanel.add(patoFileName);
			final JButton patoButton = new JButton("...");
			patoButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final ActionEvent e) {

					// tH_I_CAOĂяo
					JFileChooser fileChooser = new JFileChooser(openFolderPath);

					// tH_Iʎ擾
					int result = fileChooser.showOpenDialog(mainPanel);
					patoPath = fileChooser.getSelectedFile();
					if (result == JFileChooser.CANCEL_OPTION || patoPath == null) {
						// LZA܂́AtH_IȂ̂߉Ȃ
						return;
					}
					patoFileName.setText(patoPath.getAbsolutePath());
					tmpPath.setProperty(PREV_PATO_FILE, patoPath.getAbsolutePath());
				}
			});
		    gbc.gridx = 1;
		    gbc.gridy = 3;
		    gbc.fill = GridBagConstraints.NONE;
		    layout.setConstraints(patoButton, gbc);
			mainPanel.add(patoButton);

			JLabel convLabe = new JLabel(" new file after conversion: ");
		    gbc.gridx = 0;
		    gbc.gridy = 4;
		    layout.setConstraints(convLabe, gbc);
			mainPanel.add(convLabe);

			final JTextField eavFileName = new JTextField(60);
			if (tmpPath.getProperty(PREV_REF_FILE) != null && tmpPath.getProperty(PREV_REF_FILE).length() > 0) {
				eavFileName.setText(tmpPath.getProperty(PREV_REF_FILE));
				eavPath = new File(tmpPath.getProperty(PREV_REF_FILE));
			}
		    gbc.gridx = 0;
		    gbc.gridy = 5;
		    gbc.fill = GridBagConstraints.HORIZONTAL;
		    layout.setConstraints(eavFileName, gbc);
			mainPanel.add(eavFileName);
			final JButton eavButton = new JButton("...");
			eavButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final ActionEvent e) {

					// tH_I_CAOĂяo
					JFileChooser fileChooser = new JFileChooser(openFolderPath);

					// tH_Iʎ擾
					int result = fileChooser.showOpenDialog(mainPanel);
					eavPath = fileChooser.getSelectedFile();
					if (result == JFileChooser.CANCEL_OPTION || eavPath == null) {
						// LZA܂́AtH_IȂ̂߉Ȃ
						return;
					}
					eavFileName.setText(eavPath.getAbsolutePath());
					tmpPath.setProperty(PREV_REF_FILE, eavPath.getAbsolutePath());
				}
			});
		    gbc.gridx = 1;
		    gbc.gridy = 5;
		    gbc.fill = GridBagConstraints.NONE;
		    layout.setConstraints(eavButton, gbc);
			mainPanel.add(eavButton);

			JLabel orgaLabe = new JLabel(" Organism: ");
		    gbc.gridx = 0;
		    gbc.gridy = 6;
		    layout.setConstraints(orgaLabe, gbc);
			mainPanel.add(orgaLabe);

			final JTextField oranismName = new JTextField(60);
			if (tmpPath.getProperty(PREV_ORGAN_FILE) != null && tmpPath.getProperty(PREV_ORGAN_FILE).length() > 0) {
				oranismName.setText(tmpPath.getProperty(PREV_ORGAN_FILE));
				conceptLabel = tmpPath.getProperty(PREV_ORGAN_FILE);
			}
		    gbc.gridx = 0;
		    gbc.gridy = 7;
		    gbc.fill = GridBagConstraints.HORIZONTAL;
		    layout.setConstraints(oranismName, gbc);
			mainPanel.add(oranismName);
			final JButton oranButton = new JButton("...");
			oranButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final ActionEvent e) {

					// I_CAOĂяo
					if (ont == null && patoPath.getAbsolutePath() != null) {
						ont = new HZOntology();
						ont.setSource(patoPath.getAbsolutePath());
						try {
							ont.load();
						} catch(Exception ontExc) {
							ontExc.printStackTrace();
							System.out.println("...Fault");
						}
					} else if (ont == null && patoPath.getAbsolutePath() == null) {
					    JLabel label = new JLabel("IgW[w肵ĂB");
					    JOptionPane.showMessageDialog(mainPanel, label);
					}
					ConceptSelectionDialog conceptChooser = new ConceptSelectionDialog(ont, "Any", false, false, ConceptTreePanel.TREE_TYPE_WHOLE_ONLY);
					conceptChooser.getTree().setTree(ont);	// ׂĕ\
					String selText = oranismName.getText();
					if (selText != null && !selText.isEmpty()) {
						conceptChooser.getTree().setSearchTreeByLabel(selText);
						conceptChooser.setSelectedText(selText);
					}
					conceptChooser.setModal(true);
					conceptChooser.setVisible(true);

					// Iʎ擾
					// OK ꂽꍇ̂݌͈͂XV
					if (conceptChooser.isOK() == true) {
						oranismName.setText(conceptChooser.getSelectedText());
						conceptLabel = conceptChooser.getSelectedText();
						tmpPath.setProperty(PREV_ORGAN_FILE, conceptLabel);
					}
				}
			});
		    gbc.gridx = 1;
		    gbc.gridy = 7;
		    gbc.fill = GridBagConstraints.NONE;
		    layout.setConstraints(oranButton, gbc);
			mainPanel.add(oranButton);

			final JButton closeButton = new JButton("close");
			closeButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final ActionEvent e) {
					try {
						tmpPath.store(new FileOutputStream(PREV_INFO_FILE), null);
					} catch (Exception efile) {  
						System.out.println("Exception : " + efile);  
					}  
					dispose();
				}
			});

			final JButton submitButton = new JButton("convert...");
			submitButton.addActionListener(new java.awt.event.ActionListener() {
				
				public void actionPerformed(final ActionEvent e) {
					// t@Cw`FbN
				    JLabel label = new JLabel();
				    oboPath = new File(oboFileName.getText());
				    patoPath = new File(patoFileName.getText());
				    eavPath = new File(eavFileName.getText());
				    conceptLabel = oranismName.getText();
				    tmpPath.setProperty(PREV_OBO_FILE, oboFileName.getText());
				    tmpPath.setProperty(PREV_PATO_FILE, patoFileName.getText());
				    tmpPath.setProperty(PREV_REF_FILE, eavFileName.getText());
				    tmpPath.setProperty(PREV_ORGAN_FILE, conceptLabel);
					try {
						tmpPath.store(new FileOutputStream(PREV_INFO_FILE), null);
					} catch (Exception efile) {  
						System.out.println("Exception : " + efile);  
					}  

				    if (oboPath == null || oboPath.getPath().length() == 0) {
						label.setText("Ή\t@Cw肵ĂB");
					    JOptionPane.showMessageDialog(mainPanel, label);
					    return;
					}
					if (patoPath == null || patoPath.getPath().length() == 0) {
						label.setText("QƃIgW[w肵ĂB");
					    JOptionPane.showMessageDialog(mainPanel, label);
					    return;
					}
					if (eavPath == null || eavPath.getPath().length() == 0) {
						label.setText("ϊIgW[w肵ĂB");
					    JOptionPane.showMessageDialog(mainPanel, label);
					    return;
					}
					if (conceptLabel == null || conceptLabel.length() == 0) {
						label.setText("w肵ĂB");
					    JOptionPane.showMessageDialog(mainPanel, label);
					    return;
					}
					convertEQ2EAV();
					try {
						tmpPath.store(new FileOutputStream(PREV_INFO_FILE), null);
					} catch (Exception efile) {  
						System.out.println("Exception : " + efile);  
					}
					setVisible(false);
				}
			});

			final JPanel submitPanel = new JPanel(new FlowLayout());
			submitPanel.add(submitButton);
			submitPanel.add(closeButton);
			gbc.gridx = 0;
		    gbc.gridy = 8;
		    gbc.gridwidth = 2;
			gbc.anchor = GridBagConstraints.CENTER;
		    layout.setConstraints(submitPanel, gbc);
			mainPanel.add(submitPanel);
		}

		/**
		 * EQEAVIgW[ɕϊ
		 */
		private void convertEQ2EAV() {
			EQ2EAV tr = new EQ2EAV();

			// QƃIgW[t@C̓Ǎ
			tr.data_set1 = new TreeMap<String, String[]>();
			tr.data_set2 = new TreeMap<String, String[]>();
			tr.data_set3 = new TreeMap<String, String[]>();
			// inputf[^Xg
			tr.input_data1 = new ArrayList<String[]>();
			tr.input_data2 = new ArrayList<String[]>();
				
			// QƃIgW[쐬
			tr.ontRef = new HZOntology();

			// ʃt@CXg[
			try {
				tr.resultFile = new FileOutputStream(RESULT_FILE_NAME);
				tr.resultWriter = new OutputStreamWriter(tr.resultFile, "utf-8");	
			} catch (IOException e) {
				System.out.println(e.getMessage());
			}
			TestTimer timer = new TestTimer();
			timer.start();
				
			// Ή\Ǎ
			String oboFileName = this.oboPath.getAbsolutePath();
			if (oboFileName != null) {
				System.out.println("------- step[1]:Ή\Ǎ --------");
				tr.loadData(oboFileName);
			} else {
				System.out.println("Ή\t@Cw肵ĂB");
			}

			// QƃIgW[t@C̎w
			String patoFileName = this.patoPath.getAbsolutePath();
			if (patoFileName != null) {
				tr.ontRef.setSource(patoFileName);
			} else {
				System.out.println("QƃIgW[t@Cw肵ĂB");
			}
				
			// o̓IgW[t@C̎w
			String eavFileName = this.eavPath.getAbsolutePath();
			if (eavFileName != null) {
				tr.fileName = eavFileName;
			} else {
				System.out.println("ۑIgW[t@Cw肵ĂB");
			}
				
			// ̎w
			if (this.conceptLabel != null) {
				tr.species = this.conceptLabel;
			} else {
				System.out.println("w肵ĂB");
			}

			try {
				System.out.println("------- step[2]:QƃIgW[Ǎ -------");
				tr.ontRef.load(this.DEFAULT_PARSER);
			} catch (Exception e) {
				System.out.println(e.getMessage());
			}
				
			// 쐬
			System.out.println("------- step[3]:𐶐 -------");
			tr.speciesConcept = tr.createSpecies(tr, tr.ontRef, tr.species);
			if (tr.speciesConcept == null) {
				return;
			}
				
			// ύXIgW[쐬
			// DoubleTOo
			System.out.println("------- step[4]:doubleo -------");
			tr.outputInputdataDouble();
			// TripleTOo
			System.out.println("------- step[5]:tripleo -------");
			tr.outputInputdataTriple();
			// DoubleʊTOo
			System.out.println("------- step[6]:double  EAVɕϊ -------");
			tr.outputResultDouble();
			// TripleʊTOo
			System.out.println("------- step[7]:triple  EAVɕϊ -------");
			tr.outputResultTriple();
			// I^Oo
			tr.outputFooter();

			// ʂɔf
			ontTree = updateTree();
			ontTree.setTree(tr.ontRef);
			frame.setTitle(FRAME_TITLE + " - [ " + eavFileName + " ]");
			frame.repaint();

			// plɔf
			ontSearchPanel.setOntology(tr.ontRef);
			ontSearchPanel.setSimilarityThreshold(0.1);
			// TODO: SimilarityThreshold ́Aݒt@Cǂݍ݁H
			
			ontSearchPanel.setScopeTreeType(treeType);
			
			saveOnt = tr.ontRef;
			
			saveOnt.setSource(eavFileName);
			
			Concept concept = saveOnt.findBasicConceptByLabel(conceptLabel);
			ontTree.setSelectTree(concept);
			paintGraphPanel((Concept)concept);
			
			// ʃt@CXg[N[Y
			try {
				tr.resultWriter.close();
				tr.resultFile.close();
			} catch (IOException e) {
				System.out.println(e.getMessage());
			}

			// ϊʂ\
			ResultPanel result = new ResultPanel();
			result.setAlwaysOnTop(true);
			result.setVisible(true);

		}
	}

	/**
	 * ʓe̕\pl
	 */
	class ResultPanel extends JFrame {

		/**
		 *
		 */
		private static final long serialVersionUID = 8942290757928495172L;

		/** ʕ\鏈ʓe */
		JTextArea infoPane;

		private static final String RESULT_FILE_NAME = "result.txt";

		/**
		 * RXgN^
		 */
		public ResultPanel() {

			final Container contentPane = getContentPane();

			setTitle("Result");
			setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
			final int width = 400;
			final int height = 400;
			setPreferredSize(new Dimension(width, height));
			pack();
			setLocationRelativeTo(frame);	// eɒ\ipack()OɌĂяoĂj

			// ʏt@CǍ
		    try {
		    	infoPane = new JTextArea();
		    	
				/** ϊʏۑt@C */
				FileInputStream fis = new FileInputStream(RESULT_FILE_NAME); 
				InputStreamReader resultInfoFile = new InputStreamReader(fis , "utf-8"); 
	            BufferedReader br = new BufferedReader(resultInfoFile);
	            String line;
	            while ((line = br.readLine()) != null) {
	            	infoPane.append(line);
	            	infoPane.append("\n");
	            }
	            br.close();
	            resultInfoFile.close();
		        
		    } catch (IOException e) {
		    	e.printStackTrace();
		    }
		    
		    contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.Y_AXIS));
		    
			//contentPane.add(infoPane, BorderLayout.NORTH);
		    JScrollPane scrlPane = new JScrollPane(infoPane, 
				    		JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, 
				    		JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
			//contentPane.add(scrlPane, BorderLayout.NORTH);
			contentPane.add(scrlPane);

			final JButton button = new JButton("close");
			final ResultPanel panel = this;
			button.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(final ActionEvent e) {
					panel.setVisible(false);
					FolderPanel folderPanel = new FolderPanel();
					folderPanel.setVisible(true);
				}
			});

			final JPanel southPanel = new JPanel();
			southPanel.setMaximumSize(new Dimension(300, 50));
			southPanel.add(button, BorderLayout.CENTER);
			//contentPane.add(southPanel, BorderLayout.SOUTH);
			contentPane.add(southPanel);

			addWindowListener(new WindowAdapter() {
	            public void windowClosing(WindowEvent e)  {
					panel.setVisible(false);
					FolderPanel folderPanel = new FolderPanel();
					folderPanel.setVisible(true);
	            }
	       });

		}
	}
	// End ResultPanel

	/**
	 * ConceptTree NX̊gB
	 */
	class MyOntoTree extends ConceptTreePanel {

		EQ2EAVTool main;

		/**
		 * RXgN^
		 */
		MyOntoTree(EQ2EAVTool m, boolean multipleSelected, int type, boolean slotVisible) {
			super(multipleSelected, type, slotVisible);
			main = m;
		}

		/**
		 * c[ICxg
		 */
		public void mouseAction(MouseEvent e) {

//			if (this.selectedNode == null) {
			if (this.getSelectedNode() == null) {
				return;
			}

//			HozoObject obj = this.selectedNode.getHozoObject();
			HozoObject obj = this.getSelectedNode().getHozoObject();
			if (obj instanceof Concept) {
				this.main.paintGraphPanel((Concept)obj);
			} else if (obj instanceof Slot){
				Slot slot = (Slot)obj;
				Concept con = slot.getOwnerConcept();
				this.main.paintGraphPanel(con, slot);
			}

		}

		@Override
		public void actionSelected() {

//			if (this.selectedNode == null) {
			if (this.getSelectedNode() == null) {
				return;
			}

//			HozoObject obj = this.selectedNode.getHozoObject();
			HozoObject obj = this.getSelectedNode().getHozoObject();
			if (obj instanceof Concept) {
				this.main.paintGraphPanel((Concept)obj);
			}
		}
	}
	// End MyOntoTree

	/**
	 * ConceptGraphPanel NX̊gB
	 */
	class MyOntoGraphPanel extends jp.hozo.oat.ConceptGraphPanel {
//	class MyOntoGraphPanel extends ConceptGraphPanel {

		EQ2EAVTool main;

		/**
		 * RXgN^
		 */
		MyOntoGraphPanel(EQ2EAVTool m) {
			super(false, true);
			main = m;
		}

		@Override
		public void doubleClickEvent(MouseEvent e){
			Concept concept = this.getConcept();
			if (concept != null) {
				//System.out.println(concept.getLabel());
				main.ontTree.selectConceptNode(concept);
				main.paintGraphPanel(concept);
				return;
			}
			// NX̃Wv̒ǉ
			Slot slot = this.getSelectedSlot();
			if (slot != null && slot.getConstraintConcept() != null) {
				//System.out.println(slot.getPath());
				Concept constConcept = slot.getConstraintConcept();
				Slot depSlot = null;
				// [z_[
				if (constConcept instanceof RoleHolder) {
					depSlot = ((RoleHolder) constConcept).getDependentSlot();
					constConcept = depSlot.getOwnerConcept();
				} 
				// TO
				else if (constConcept instanceof SpeciesConcept) {
					constConcept = ((SpeciesConcept) constConcept).getOriginalConcept();
				}
				// p-Iy[^
				else if (constConcept instanceof P_Operator) {
					constConcept = ((P_Operator) constConcept).getPartOfConcept();
				}
				// r-Iy[^
				else if (constConcept instanceof R_Operator) {
					constConcept = ((R_Operator) constConcept).getRegionOfConcept();
				}
				main.ontTree.selectConceptNode(constConcept);
				main.paintGraphPanel(constConcept);
				if (depSlot != null) {
					main.graphPanel.setSelectedSlot(depSlot);
				}
			}
		}
		
//		/**
//		 * _uNbNCxg
//		 */
/*		public void doubleClickEvnet(MouseEvent e) {

			Concept concept = this.selectedConstaintConcept;
			if (concept != null) {
				main.ontTree.selectConceptNode(concept);
				main.paintGraphPanel(concept);
			}
			this.repaint();
		}*/
	}
	// End MyOntoGraphPanel

	/**
	 * ConceptSearchPanel NX̊gB
	 */
	class MyOntoSearchPanel extends ConceptSearchPanel {

		EQ2EAVTool main;

		/**
		 * RXgN^
		 */
		MyOntoSearchPanel(EQ2EAVTool m,
				Component parentComponent,
				ConceptSearchPanel.SearchTabOption searchTabOption,
				boolean multipleSelected,
				boolean hasCheckBox) {

			super(parentComponent, searchTabOption, multipleSelected, hasCheckBox);
			main = m;
		}

		/**
		 * ̃CxgB<P>
		 */
		public void searchFinishAction(SearchReport searchReport) {
			this.main.setSearchResultCount(searchReport.getResultCount());
		}

		/**
		 * ̃CxgB<>
		 */
		public void searchFinishAction(List<SearchReport> searchReportList) {
			int searchReport = 0;
			for (int i = 0; i < searchReportList.size(); i++) {
				searchReport += searchReportList.get(i).getResultCount();
			}
			this.main.setSearchResultCount(searchReport);
		}

		/**
		 * e[us_uNbNCxg
		 */
		public void tableRowDoubleClickAction(SearchResult searchResult) {
			HozoObject obj = searchResult.getHozoObject();
			// TȌꍇ
			if (obj instanceof Concept) {
				// [z_[̏ꍇ
				if (obj instanceof RoleHolder) {
					Slot depSlot = ((RoleHolder) obj).getDependentSlot();
					this.main.paintGraphPanel(depSlot.getOwnerConcept(), depSlot);
				} else {
					this.main.paintGraphPanel((Concept) obj);
				}
			}
			// Xbg̏ꍇ
			else if (obj instanceof Slot) {
				Slot slot = (Slot) obj;
				this.main.paintGraphPanel(slot.getOwnerConcept(), slot);
			}
			// ֌WN̏ꍇ
			else if (obj instanceof RConceptRelation) {
				RConceptRelation relation = (RConceptRelation) obj;
				if (relation.getRSlotRelation(0) != null) {
					Slot relSlot = relation.getRSlotRelation(0).getRelationSlot();
					this.main.paintGraphPanel(relSlot.getOwnerConcept());
				}
			}
			frame.validate();
			frame.repaint();
		}
	}
	// End MyOntoSearchPanel
	
	class InheritPanel extends JPanel {
		private JCheckBox inherit;
		public InheritPanel(){
			inherit = new JCheckBox("pXbg\");
			inherit.addActionListener(new ActionListener() {
				
				public void actionPerformed(ActionEvent e) {
					graphPanel.setIncludeInherit(inherit.isSelected());
					graphPanel.update();
					frame.validate();
					frame.repaint();
				}
			});
			this.add(inherit);
		}
	}
	// End InheritPanel
	
	class MyConceptSelectionDialog extends ConceptSelectionDialog {
		
		public MyConceptSelectionDialog(HZOntology ontology) {
			super(ontology);
		}
		
		public MyConceptSelectionDialog(HZOntology ontology, String rootLabel, boolean multipleSelected, boolean hasCheckBox, boolean hasOrButton, int order) {
			super(ontology, rootLabel, multipleSelected, hasCheckBox, hasOrButton, order);
		}
		
		/**
		 * c[IԂɂ
		 *
		 * @param text
		 */
		@SuppressWarnings("unchecked")
		public void setSelectionPath(String text) {
			ConceptTree tree = getTree().getTree();
			tree.setRootVisible(false);
			DefaultMutableTreeNode root = (DefaultMutableTreeNode) tree.getModel().getRoot();
			List<DefaultMutableTreeNode> nodes = Collections.<DefaultMutableTreeNode>list(root.breadthFirstEnumeration());
			for (DefaultMutableTreeNode node : nodes) {
				if (node != null && node.toString().equals(text)) {
					TreePath path = new TreePath(node.getPath());
					tree.setSelectionPath(path);
					tree.scrollPathToVisible(path);
					break;
				}
			}
		}
	}
	// End MyConceptSelectionDialog
	
	class EAVSetupFrame extends JFrame {
		/**
		 * 
		 */
		private static final long serialVersionUID = 149L;

		// I_CAO
		private ConceptSelectionDialog conceptSelect;

		// entity̓eLXgGA
		private TextField et = new TextField("experimental group of animals", 25);
		// attribute̓eLXgGA
		private TextField at = new TextField("non-meta generic quality", 25);		//basic generic quality
		// vlue̓eLXgGA
		private TextField vt = new TextField("quality value", 25);
		// EVA Form̓eLXgGA
		private TextField ft = new TextField("EAV", 25);
		// JȗtO
		private JCheckBox jCB_ShortCut = new JCheckBox("convert column name to symbol");
		private boolean isShortCut = false;
		// l}XN
		private JCheckBox jCB_ValueMask = new JCheckBox("mask cell which has some values");
		private boolean isValueMasked = false;
		//J̕ɂ
		private JCheckBox jCB_AutoResizeColumn = new JCheckBox("resize column automatically");
		private boolean isAutoResizeColumn = false;
		// J̕w
		private TextField jT_ColumnSize = new TextField("30");
		//sƗւ
		private JCheckBox jCB_ReplaceLineToColumn = new JCheckBox("replace \"E\"(row) to \"A\"(column)");
		private boolean isReplacedLineToColumn = false;
		
		//sƗւ
		private JCheckBox jCB_RemoveEmptyColumn = new JCheckBox("remove empty columns");
		private boolean isRemovedEmptyColumn = false;
		
		EAVSetupFrame() {
			this.setTitle("Please select E_A_V Concepts");
			
			JLabel el = new JLabel("E:"); 
			JLabel al = new JLabel("A:"); 
			JLabel vl = new JLabel("V:");
			JLabel fl = new JLabel("Form:");
			JButton eb = new JButton("c");
			JButton ab = new JButton("c");
			JButton vb = new JButton("c");
			JButton fb = new JButton("c");
			JButton ok = new JButton("OK");
			JButton cancel = new JButton("Cancel");
			
			jCB_AutoResizeColumn.addChangeListener(new ChangeListener() {
				public void stateChanged(ChangeEvent e) {
					isAutoResizeColumn = jCB_AutoResizeColumn.isSelected();
					if (!isAutoResizeColumn) {
						jT_ColumnSize.setEditable(true);
					} else {
						jT_ColumnSize.setEditable(false);
					}
				}
			});
			jCB_AutoResizeColumn.setSelected(true);
			jT_ColumnSize.setEditable(false);
			jT_ColumnSize.setMaximumSize(new Dimension(30, 25));
			jT_ColumnSize.setPreferredSize(new Dimension(30, 25));

			setBounds(250, 250, 350, 370);
			setResizable(false);

		    JPanel p = new JPanel();
		    GridBagLayout layout = new GridBagLayout();
		    p.setLayout(layout);
		    
			GridBagConstraints gbc = new GridBagConstraints();
			gbc.fill = GridBagConstraints.BOTH;

		    gbc.gridx = 0;
		    gbc.gridy = 0;
		    gbc.insets = new Insets(5,5,5,5);
		    layout.setConstraints(el, gbc);
		    p.add(el, gbc);
			gbc.gridx = 1;
			layout.setConstraints(et, gbc);
		    p.add(et, gbc);
			gbc.gridx = 2;
			layout.setConstraints(eb, gbc);
		    p.add(eb, gbc);
			gbc.gridx = 0;
		    gbc.gridy = 1;
		    layout.setConstraints(al, gbc);
		    p.add(al, gbc);
			gbc.gridx = 1;
			layout.setConstraints(at, gbc);
		    p.add(at, gbc);
			gbc.gridx = 2;
			layout.setConstraints(ab, gbc);
		    p.add(ab, gbc);
			gbc.gridx = 0;
		    gbc.gridy = 2;
		    layout.setConstraints(vl, gbc);
		    p.add(vl, gbc);
			gbc.gridx = 1;
			layout.setConstraints(vt, gbc);
		    p.add(vt, gbc);
			gbc.gridx = 2;
			layout.setConstraints(vb, gbc);
		    p.add(vb, gbc);
			gbc.gridx = 0;
		    gbc.gridy = 3;
		    layout.setConstraints(fl, gbc);
		    p.add(fl, gbc);
			gbc.gridx = 1;
			layout.setConstraints(ft, gbc);
		    p.add(ft, gbc);
			gbc.gridx = 2;
			layout.setConstraints(fb, gbc);
		    p.add(fb, gbc);
		    
		    gbc.gridy = 4;
			gbc.gridx = 1;
		    layout.setConstraints(jCB_AutoResizeColumn, gbc);
		    p.add(jCB_AutoResizeColumn, gbc);
			gbc.gridx = 2;
			layout.setConstraints(jT_ColumnSize, gbc);
		    p.add(jT_ColumnSize, gbc);
		    
		    gbc.gridy = 5;
			gbc.gridx = 1;
			layout.setConstraints(jCB_ShortCut, gbc);
		    p.add(jCB_ShortCut, gbc);
		    gbc.gridy = 6;
			gbc.gridx = 1;
		    layout.setConstraints(jCB_ValueMask, gbc);
		    p.add(jCB_ValueMask, gbc);
		    gbc.gridy = 7;
			gbc.gridx = 1;
		    layout.setConstraints(jCB_ReplaceLineToColumn, gbc);
		    p.add(jCB_ReplaceLineToColumn, gbc);   
		    gbc.gridy = 8;
			gbc.gridx = 1;
		    layout.setConstraints(jCB_RemoveEmptyColumn, gbc);
		    p.add(jCB_RemoveEmptyColumn, gbc); 		    	    
		    
		    // entityI
		    eb.addActionListener(new ActionListener() {
	            public void actionPerformed(ActionEvent e) {
	            	conceptSelect = new MyConceptSelectionDialog(ont, null, false, false, true, ConceptTreePanel.TREE_TYPE_WHOLE_ONLY);
	            	((MyConceptSelectionDialog) conceptSelect).setSelectionPath(et.getText());
	            	conceptSelect.setModal(true);
	            	conceptSelect.setLocation(650, 300);
	            	conceptSelect.setAlwaysOnTop(true);
	            	conceptSelect.setVisible(true);

	    			// OK ꂽꍇ̂entity͂XV
	    			if (conceptSelect.isOK() == true) {
	    				et.setText(conceptSelect.getSelectedText());
	    			}
	            }
	        });
		    // attributeI
		    ab.addActionListener(new ActionListener() {
	            public void actionPerformed(ActionEvent e) {
	            	conceptSelect = new MyConceptSelectionDialog(ont, null, false, false, true, ConceptTreePanel.TREE_TYPE_WHOLE_ONLY);
	            	((MyConceptSelectionDialog) conceptSelect).setSelectionPath(at.getText());
	            	conceptSelect.setModal(true);
	            	conceptSelect.setLocation(650, 300);
	            	conceptSelect.setAlwaysOnTop(true);
	            	conceptSelect.setVisible(true);

	    			// OK ꂽꍇ̂attribute͂XV
	    			if (conceptSelect.isOK() == true) {
	    				at.setText(conceptSelect.getSelectedText());
	    			}
	            }
	        });
		    // valueI
		    vb.addActionListener(new ActionListener() {
	            public void actionPerformed(ActionEvent e) {
	            	conceptSelect = new MyConceptSelectionDialog(ont, null, false, false, true, ConceptTreePanel.TREE_TYPE_WHOLE_ONLY);
	            	((MyConceptSelectionDialog) conceptSelect).setSelectionPath(vt.getText());
	            	conceptSelect.setModal(true);
	            	conceptSelect.setLocation(650, 300);
	            	conceptSelect.setAlwaysOnTop(true);
	            	conceptSelect.setVisible(true);

	    			// OK ꂽꍇ̂value͂XV
	    			if (conceptSelect.isOK() == true) {
	    				vt.setText(conceptSelect.getSelectedText());
	    			}
	            }
	        });
		    // formI
		    fb.addActionListener(new ActionListener() {
	            public void actionPerformed(ActionEvent e) {
	            	conceptSelect = new MyConceptSelectionDialog(ont, null, false, false, true, ConceptTreePanel.TREE_TYPE_WHOLE_ONLY);
	            	((MyConceptSelectionDialog) conceptSelect).setSelectionPath(ft.getText());
	            	conceptSelect.setModal(true);
	            	conceptSelect.setLocation(650, 300);
	            	conceptSelect.setAlwaysOnTop(true);
	            	conceptSelect.setVisible(true);

	    			// OK ꂽꍇ̂value͂XV
	    			if (conceptSelect.isOK() == true) {
	    				ft.setText(conceptSelect.getSelectedText());
	    			}
	            }
	        });
		    
		    jCB_ShortCut.addActionListener(new ActionListener() {
	            public void actionPerformed(ActionEvent e) {
	            	isShortCut = jCB_ShortCut.isSelected();
	            }
		    });
		    jCB_ValueMask.addActionListener(new ActionListener() {
	            public void actionPerformed(ActionEvent e) {
	            	isValueMasked = jCB_ValueMask.isSelected();
	            }
		    });
		    jCB_ReplaceLineToColumn.addActionListener(new ActionListener() {
	            public void actionPerformed(ActionEvent e) {
	            	isReplacedLineToColumn = jCB_ReplaceLineToColumn.isSelected();
	            }
		    });
		    jCB_RemoveEmptyColumn.addActionListener(new ActionListener() {
	            public void actionPerformed(ActionEvent e) {
	            	isRemovedEmptyColumn = jCB_RemoveEmptyColumn.isSelected();
	            }
		    });
		    jCB_RemoveEmptyColumn.setSelected(true);
		    isRemovedEmptyColumn = true;
		    
		    // c[e[u쐬
		    ok.addActionListener(new ActionListener() {
	            public void actionPerformed(ActionEvent e) {
	            	setEntityValue(et.getText());
	            	setAttributeValue(at.getText());
	            	setValue(vt.getText());
	            	setEVAForm(ft.getText());
	            	setVisible(false);
	            	//createTreeTable(shortCut);
	            	//createTreeTable(shortCut, isValueMasked);
	            	String size = jT_ColumnSize.getText();
	            	isRemovedEmptyColumn = jCB_RemoveEmptyColumn.isSelected();
	            	if (!isAutoResizeColumn && Integer.parseInt(size) > 0) {
	            		createTreeTable(jCB_ShortCut.isSelected(), jCB_ValueMask.isSelected(), Integer.parseInt(size), isReplacedLineToColumn, isRemovedEmptyColumn); 
	            	} else {
	            		createTreeTable(jCB_ShortCut.isSelected(), jCB_ValueMask.isSelected(), -1, isReplacedLineToColumn, isRemovedEmptyColumn); 
	            	}
	            }
	        });
		    // LZ
		    cancel.addActionListener(new ActionListener() {
	            public void actionPerformed(ActionEvent e) {
	            	setVisible(false);
	            }
	        });

		    // `
		    getContentPane().add(p, BorderLayout.CENTER);
			JPanel pk = new JPanel();
			pk.add(ok);
			pk.add(cancel);
		    getContentPane().add(pk, BorderLayout.SOUTH);
		}
		
		public void setET(String value) {
			this.et.setText(value);
		}

		public void setAT(String value) {
			this.at.setText(value);
		}

		public void setVT(String value) {
			this.vt.setText(value);
		}
		
		// WindowƂɂ͔\ɂ
		protected void processWindowEvent (WindowEvent e) {
			//    super.processWindowEvent(e);
			if(e.getID() == WindowEvent.WINDOW_CLOSING) {
				this.setVisible(false);
			}
		}
	}
	// End EAVSetupFrame
	
	/**
	 * c[e[u\
	 * 
	 */
	class TreeTableFrame extends JFrame {
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		
		private boolean isShortColName = false;

	    /** Model for the JTreeTable. */
		protected ConceptTreeTableModel treeTableModel;
		/** JTreeTable */
		protected JXTreeTable treeTable;
	    /** Used to indicate status. */
	    protected JLabel statusLabel;
	    /** Frame containing everything. */
	    protected JFrame frame;
	    /** entity created with. */
	    protected Concept entityConcept;
	    /** Attribute Concept */
	    protected Concept attributeConcept;
	    /** Value Concept */
	    protected Concept valueConcept;
	    /** entity created with. */
	    protected Concept eavRepresentConcept;
	    // J}
	    private int colCnt = 1;
	    // Jz
	    private List<String> colNames = new ArrayList<String>();
	    // ȗJKwJE^[
	    private int groupCnt = 1;
	    private int groupLabel = 1;
	    // JXg
	    protected List<ColumnNames> columnz;
	    
	    // ړ
		private static final String PREFIX = "(*)";
		
		private JMenuBar tableMenuBar;
		
		// ȗ̃J
		private static final int COLUMN_SIZE = 30;
		// J
		private int columnWidth = -1;

		// sƗւ邩ǂH
		protected boolean isReplacedLineToColumn = false;
		
		// J폜邩ǂH
		protected boolean isRemovedEmptyColumn = false;
		
		// IĂc[m[h
		private ConceptTreeNode selectedTreeNode;
		
		// e[uJO[vXg
		private List<ColumnGroup> columnGroupArray;
		
		// c[J|bvAbvj[
		private TreeTablePopupMenu jPM_TreeTable;
		// c[J|bvAbvj[
		private TableColumnPopupMenu jPM_TableColumn;
		
		//
		private static final String LARGE = "large";
		private static final String MIDDLE = "middle";
		private static final String SMALL = "small";
		private static final String UPPER_THRESHOLD = "upper threshold";
		private static final String LOWER_THRESHOLD = "lower threshold";
		

		TreeTableFrame(boolean isShortCut) {
			this(isShortCut, false);
		}
		TreeTableFrame(boolean isShortCut, boolean isValueMasked) {
			this(isShortCut, isValueMasked, -1);
		}
		TreeTableFrame(boolean isShortCut, boolean isValueMasked, int columnWidth) {
			this(isShortCut, isValueMasked, columnWidth, false, false);
		}
		TreeTableFrame(boolean isShortCut, boolean isValueMasked, int columnWidth, boolean replaceLineToColumn, boolean removeEmptyColumn) {
		    super( "E_A_V Table" );

		    this.columnWidth = columnWidth;
		    this.isReplacedLineToColumn = replaceLineToColumn;
		    this.isRemovedEmptyColumn = removeEmptyColumn;
		    this.isShortColName = isShortCut;
		    
		    this.jPM_TreeTable = new TreeTablePopupMenu(this);
		    this.jPM_TableColumn = new TableColumnPopupMenu(this);
		    
		    // \J擾
//		    List<ColumnNames> columnz = getColumnArray();
		    columnz = getColumnArray();
		    if (columnz == null) {
				JOptionPane.showMessageDialog(this, "\ΏۂƂȂ鑮(A)܂łB");
				dispose();
				return;
		    }
		    // [gTO擾
		    entityConcept = ont.findConceptByLabel(getEntityValue(), WholeConcept.CONCEPT_TYPE);
		    if (entityConcept == null) {
				JOptionPane.showMessageDialog(this, "\ΏۂƂȂGeBeB(E)܂łB");
				dispose();
				return;
		    }
		    // lTO擾
		    valueConcept = ont.findConceptByLabel(getValue(), WholeConcept.CONCEPT_TYPE);
		    if (valueConcept == null) {
				JOptionPane.showMessageDialog(this, "\ΏۂƂȂl(V)܂łB");
				dispose();
				return;
		    }
		    // EAV\
		    eavRepresentConcept = ont.findConceptByLabel(getEVAForm(), WholeConcept.CONCEPT_TYPE);
		    if (eavRepresentConcept == null) {
				JOptionPane.showMessageDialog(this, "\ΏۂƂȂEAV\܂łB");
				dispose();
				return;
		    }
		    
		    // e[uɕ\f[^
//		    treeTableModel = new ConceptTreeTableModel(entity, ont, getColumnNames(), eavRepresent);
//		    treeTableModel = new ConceptTreeTableModel(entity, ont, getColumnNames(), eavRepresent, isValueMasked);
		    if (isReplacedLineToColumn) {
//		    	treeTableModel = new ConceptTreeTableModel(attributeConcept, ont, getColumnNames(), valueConcept, eavRepresentConcept, isValueMasked, isReplacedLineToColumn);
		    	treeTableModel = new ConceptTreeTableModel(attributeConcept, ont, getColumnNames(), entityConcept, valueConcept, eavRepresentConcept, isValueMasked, isReplacedLineToColumn, isRemovedEmptyColumn);
		    } else {
//		    	treeTableModel = new ConceptTreeTableModel(entityConcept, ont, getColumnNames(), valueConcept, eavRepresentConcept, isValueMasked);
		    	treeTableModel = new ConceptTreeTableModel(entityConcept, ont, getColumnNames(), attributeConcept, valueConcept, eavRepresentConcept, isValueMasked, isReplacedLineToColumn, isRemovedEmptyColumn);
		    }
		    
		    // Jݒ
		    treeTableModel.setColumnNames(getColumnNames());

		    // c[e[u
			treeTable = new JXTreeTable(treeTableModel) {
				/**
				 * 
				 */
				private static final long serialVersionUID = 151L;

				protected JTableHeader createDefaultTableHeader() {
					return new GroupableTableHeader(columnModel);
				}
			};

		    TableColumnModel tableColumnModel = treeTable.getColumnModel();
		    ColumnGroup colGroup = createColumnGroup(columnz, tableColumnModel);
		    if (colGroup != null) {
			    GroupableTableHeader header = (GroupableTableHeader) treeTable.getTableHeader();
			    header.addColumnGroup(colGroup);
			    header.addMouseListener(new MouseAdapter() {
					@Override
					public void mouseClicked(MouseEvent me) {
						// _uNbN̏ꍇ
						if (me.getClickCount() > 1) {

						}
					}
			    });
		    }
		    treeTable.expandAll();	// c[J
	    
			treeTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			treeTable.setColumnSelectionAllowed(true);
			treeTable.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseClicked(MouseEvent me) {
					Point pt = me.getPoint();
					int idx = treeTable.rowAtPoint(pt);
					int idy = treeTable.columnAtPoint(pt);
					//System.out.println("[" + idx + ", " + idy + "]");
					if (idx >= 0 && idy >= 0) {
						int row = treeTable.convertRowIndexToModel(idx);
						int col = treeTable.convertColumnIndexToModel(idy);
						
						List<ConceptTreeNode> subNodes = treeTableModel.getNodeList();
						String e = (String) treeTableModel.getValueAt(subNodes.get(row), 0);
						ConceptTreeNode selectedNode = (ConceptTreeNode) treeTable.getPathForRow(row).getLastPathComponent();
						setSelectedTreeNode(selectedNode);
						String suffix = "";
						if (selectedNode != null) {
							if (selectedNode.isMerged()) {
								suffix = ConceptTreeTableModel.MERAGED_LABEL;
							} 
							e = selectedNode.getConcept().getLabel();
						}
						String a = treeTableModel.getColumnName(idy);
						String v = (String) treeTableModel.getValueAt(row, col);
						String key = e + ConceptTreeTableModel.E_A_DELIMITER + a;
						if (treeTableModel.isValueMasked()) {
							if (selectedNode.isMerged()) {
								v = selectedNode.getValueList().get(idy);
							} else {
								v = (String) treeTableModel.getCellValue(key);
								if (v == null) {
									v = ConceptTreeTableModel.BLANK_CHAR;
								}
							}
						}
						if (idy > 0) {
							// Xe[^Xo[\
							updateStatusLabel(e + suffix, a, v);
							
							// _uNbN̏ꍇ
							if (me.getClickCount() > 1) {
								List<Concept> selConList = treeTableModel.getEAVConceptList(key);
								if (selConList != null && !selConList.isEmpty()) {
									if (selConList.size() == 1) {
										paintGraphPanel(selConList.get(0));
										ontTree.selectConceptNode(selConList.get(0));
									} else {
										Concept curConcept = graphPanel.getConcept();
										int selIndex = -1;
										for (int i = 0; i < selConList.size(); i++) {
											if (selConList.get(i).equals(curConcept)) {
												selIndex = i;
												break;
											}
										}
										if (selIndex >= 0 && selIndex < selConList.size() - 1) {
											paintGraphPanel(selConList.get(selIndex + 1));
											ontTree.selectConceptNode(selConList.get(selIndex + 1));
										} else {
											paintGraphPanel(selConList.get(0));
											ontTree.selectConceptNode(selConList.get(0));
										}
									}
								}
							}
							// ENbN̏ꍇ
							else if (me.getButton() == java.awt.event.MouseEvent.BUTTON3) { // BUTTON3  ENbN
								jPM_TableColumn.show(treeTable, me.getPoint().x, me.getPoint().y);
							}
						}
						else if (idy == 0) {
							// _uNbN̏ꍇ
							if (me.getClickCount() > 1) {
								if (selectedNode != null) {
									Concept selCon = selectedNode.getConcept();
									paintGraphPanel(selCon);
									ontTree.selectConceptNode(selCon);
								}
							}
							// ENbN̏ꍇ
							else if (me.getButton() == java.awt.event.MouseEvent.BUTTON3) { // BUTTON3  ENbN
								jPM_TreeTable.updateMenu(selectedNode);
								jPM_TreeTable.show(treeTable, me.getPoint().x, me.getPoint().y);
							}
						}
					}
				}
			});
			treeTable.addTreeSelectionListener(new TreeSelectionListener() {
				public void valueChanged(TreeSelectionEvent e) {
					
				}
			});
			
//			treeTable.setDefaultRenderer(Object.class, new ConceptTreeTableCellRenderer());
			DefaultTableColumnModel cmodel = (DefaultTableColumnModel) treeTable.getColumnModel();
			Enumeration<TableColumn> en = cmodel.getColumns();
			while (en.hasMoreElements()) {
				TableColumn column = (TableColumn) en.nextElement();
				column.setCellRenderer(new ConceptTreeTableCellRenderer());
			}
			treeTable.setTreeCellRenderer(new TableConceptTreeCellRenderer());
			
			// ŏ̃JŒ肷
			tableColumnModel.getColumn(0).setPreferredWidth(250);
			// J폜
			if (isRemovedEmptyColumn) {
				removeEmptyColumns();
			}

			JScrollPane scrollPane = new JScrollPane(treeTable, 
								    		JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
								    		JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		    scrollPane.setAutoscrolls(true);
		    		    
		    // ^f[^\łȂ΁Aj[ǉ
		    if (!(this instanceof MetadataTableFrame)) {
			    tableMenuBar = new TreeTableMenuBar(this);
			    setJMenuBar(tableMenuBar);
		    }
		    
			statusLabel = createStatusLabel();
		    
		    getContentPane().add(scrollPane, BorderLayout.CENTER);
		    getContentPane().add(statusLabel, BorderLayout.SOUTH);

		    setBounds(280, 300, 800, 500);
		}
		

		public List<ColumnGroup> getColumnGroupArray() {
			if (this.columnGroupArray == null) {
				this.columnGroupArray = new ArrayList<ColumnGroup>();
			}
			return this.columnGroupArray;
		}

		public void setColumnGroupArray(List<ColumnGroup> groups) {
			this.columnGroupArray = groups;
		}
		
		// J폜
		protected void removeEmptyColumns() {
			int columnSize = colNames.size();
			List<TableColumn> columnList =  new ArrayList<TableColumn>(treeTable.getColumns());
			for (int i = 1; i < columnSize; i++) {
				boolean isEmpty = true;
				for (ConceptTreeNode treeNode : treeTableModel.getNodeList()) {
					String value = treeNode.getValueList().get(i);
					if (!value.endsWith(ConceptTreeTableModel.BLANK_CHAR)) {
						isEmpty = false;
						break;
					}
				}
				if (isEmpty) {
					TableColumn removeColumn = columnList.get(i);
					removeColumnFromGroup(removeColumn);
					treeTable.removeColumn(removeColumn);
					treeTableModel.getColumnNameList().remove(treeTableModel.getColumnNames()[i]);
				}
			}
		}
		
		// O[vJ폜
		private void removeColumnFromGroup(TableColumn column) {
			for (ColumnGroup group : getColumnGroupArray()) {
				if (group.contains(column)) {
					group.remove(column);
				}
			}
		}
		
		// WindowƂɂ͔\ɂ
		protected void processWindowEvent (WindowEvent e) {
			//    super.processWindowEvent(e);
			if(e.getID() == WindowEvent.WINDOW_CLOSING) {
				this.setVisible(false);
			}
		}

		protected JXTreeTable getTreeTable() {
			return treeTable;
		}
		
		protected ConceptTreeTableModel getTreeTableModel() {
			return treeTableModel;
		}
		
	    /**
	     * Creates and return a JLabel that is used to indicate the status
	     * of loading.
	     */
		protected JLabel createStatusLabel() {
			JLabel retLabel = new JLabel("***EAV Info***");

			retLabel.setHorizontalAlignment(JLabel.LEFT);
			retLabel.setBorder(new BevelBorder(BevelBorder.LOWERED));
			return retLabel;
	    }

	    /**
	     * Updates the status label based on reloadRow.
	     */
	    protected void updateStatusLabel(String e, String a, String v) {
	    	this.statusLabel.setText("  E: [" + e + "]  A: [" + a + "]  V: [" + v + "]");
	    }


		/**
		 * c[e[u\z񖼂擾
		 * @return 擾Jz
		 */
		private List<ColumnNames> getColumnArray() {
			if (ont == null) {
				return null;
			}
			//Concept attributeConcept = ont.findConceptByLabel(getAttributeValue(), WholeConcept.CONCEPT_TYPE);
			Concept columnCon = getAttributeConcept();
			if (isReplacedLineToColumn) {
				columnCon = getEntityConcept();
			}

			List<ColumnNames> columnList = getSubColName(columnCon);
			
			this.colNames.add(0, "");
			String[] colNames = new String[this.colNames.size()];
			int cnt = 0;
			for (String name : this.colNames) {
				colNames[cnt] = name;
				cnt++;
			}
			setColumnNames(colNames);

			return columnList;
		}
		
		/**
		 * TO擾
		 * 
		 * @return
		 */
		private Concept getEntityConcept() {
			if (entityConcept == null) {
				entityConcept = ont.findConceptByLabel(getEntityValue(), WholeConcept.CONCEPT_TYPE);
			} 
			return entityConcept;
		}
		
		/**
		 * TO擾
		 * 
		 * @return
		 */
		private Concept getAttributeConcept() {
			if (attributeConcept == null) {
				attributeConcept = ont.findConceptByLabel(getAttributeValue(), WholeConcept.CONCEPT_TYPE);
			} 
			return attributeConcept;
		}
		
		/**
		 * JXg쐬
		 * @param concept
		 * @return
		 */
		private List<ColumnNames> getSubColName(Concept concept) {
			ArrayList<ColumnNames> rtnList = new ArrayList<ColumnNames>();
			// IgW[̊TOXg琶
			List <ColumnNames> concepts = new ArrayList<ColumnNames>();
			List<String> cNames = new ArrayList<String>();
			
			ColumnNames rootColName = new ColumnNames();
			// gbvO[vJ
			rootColName.setLabel(concept.getLabel());
			rootColName.setGroupLabel(this.groupLabel);
			rootColName.addLowerConcepts(rootColName);
			rtnList.add(rootColName);
			// JXgɒǉ
			cNames.add(PREFIX + concept.getLabel());
			// ʊTO΁Aɒǉ悤ɂBJ̃O[vԍ̔Ԃ̂
			List<Concept> subConcepts = new ArrayList<Concept>(concept.getLowerConceptList());
			// ʊTOƂă[z_[ǉ
			if (concept.hasRoleHolders()) {
				subConcepts.addAll(concept.getRoleHolderList());
			}
				
//			for (Concept cp : concept.getLowerConcepts()) {
			for (Concept cp : subConcepts) {
				if (cp != null) {
					String label = cp.getLabel();
//					if (cp instanceof RoleHolder) {
//						label = ((RoleHolder) cp).getRoleHolderLabel();
//					}
					ColumnNames subColName = new ColumnNames();
					subColName.setLabel(label);
					subColName.setGroupLabel(this.groupLabel);
					subColName.setLowerConcepts(new ArrayList<ColumnNames>());
					concepts.add(subColName);
//					if (cp.hasLowerConcept()) {
					if (cp.hasLowerConcept() || cp.hasRoleHolders()) {
						// Ji[zݒ
						this.colNames.addAll(cNames);
						cNames.clear();
						this.groupLabel++;
						subColName.setGroupLabel(this.groupLabel);
						subColName.addLowerConcepts(getSubColName(cp).get(0));
					} else {
						cNames.add(label);
						rootColName.addLowerConcepts(subColName);
					}
				}
			}
			rootColName.setLowerConcepts(concepts);
		
			ColumnNames selfColName = new ColumnNames();
			// ǉiʊTOȂAO[v擪ɕ\邽߁j
			selfColName.setLabel(concept.getLabel());
			selfColName.setGroupLabel(this.groupLabel);
			selfColName.setLowerConcepts(new ArrayList<ColumnNames>());

			rtnList.get(0).getLowerConcepts().add(0, selfColName);
			// ArrayList ̃TCỸ݂TCYɏk܂B
			rtnList.trimToSize();
			// Ji[zݒ
			this.colNames.addAll(cNames);
		
			
			return rtnList;
		}

		/**
		 * JoO[v
		 */
		protected ColumnGroup createColumnGroup(List<ColumnNames> columns, TableColumnModel cm) {
			// J\ȗ(O[v)---------------------O[v
			String groupLabel = "A" + this.groupCnt;
			ColumnGroup parentGroup;
			if (this.isShortColName) {
				parentGroup = new ColumnGroup(groupLabel);
				this.groupCnt++;
			} else {
				parentGroup = new ColumnGroup(columns.get(0).getLabel());
			}
			// O[vXgɒǉ
			getColumnGroupArray().add(parentGroup);

			for (int i = 0; i < columns.size(); i++) {
				ColumnNames obj = columns.get(i);
				// qTO݂͑ꍇ
				if (obj.getLowerConcepts().size() > 0) {
					// c[̃JO[v
					for (int j = 0; j < obj.getLowerConcepts().size(); j++) {
						ColumnNames childCol = obj.getLowerConcepts().get(j);
						if (childCol.getLowerConcepts().size() > 0) {
							ColumnGroup cg = createColumnGroup(childCol.getLowerConcepts(), cm);
							parentGroup.add(cg);
						} else {
							// O[vɃJǉ-----------------------------J
							if (this.isShortColName) {
								groupLabel = "A" + this.groupCnt;
								cm.getColumn(this.colCnt).setPreferredWidth(COLUMN_SIZE);
								cm.getColumn(this.colCnt).setHeaderValue(groupLabel);
								this.groupCnt++;
							} else if (columnWidth > 0) {
								cm.getColumn(this.colCnt).setPreferredWidth(columnWidth);
							}
							parentGroup.add(cm.getColumn(this.colCnt));
							this.colCnt++;
						}
					}
				} else {
					// O[vɃJǉ-----------------------------------J
					if (this.isShortColName) {
						groupLabel = "A" + this.groupCnt;
						cm.getColumn(this.colCnt).setHeaderValue(groupLabel);
						cm.getColumn(this.colCnt).setPreferredWidth(COLUMN_SIZE);
						this.groupCnt++;
					} else if (columnWidth > 0) {
						cm.getColumn(this.colCnt).setPreferredWidth(columnWidth);
					}
					parentGroup.add(cm.getColumn(this.colCnt));
					this.colCnt++;
				}
			}

			return parentGroup;
		}

		public boolean isShortColName() {
			return isShortColName;
		}

		public void setShortColName(boolean shortColName) {
			this.isShortColName = shortColName;
		}
	
		public ConceptTreeNode getSelectedTreeNode() {
			return selectedTreeNode;
		}
		public void setSelectedTreeNode(ConceptTreeNode selectedTreeNode) {
			this.selectedTreeNode = selectedTreeNode;
			
			// j[XV
			if (tableMenuBar != null && selectedTreeNode != null) {
				((TreeTableMenuBar) tableMenuBar).updateMenu(selectedTreeNode);
			}
		}
		
		// e[ut@Co͂܂
		public void exportTable() {
			String path = (new File("./")).getAbsolutePath();
			JFileChooser filechooser = new JFileChooser(path);
			filechooser.setDialogTitle("choose a CSV(Text) file to export Table");
			filechooser.setDialogType(JFileChooser.SAVE_DIALOG);
			filechooser.setSelectedFile(new File(HZFileUtility.getFileName(ont.getLabel()) + "_table.csv")); 
			int ans = filechooser.showSaveDialog(this);
			if (ans != JFileChooser.APPROVE_OPTION) {
				return;		// Ȃ
			}
			try {
				File file = filechooser.getSelectedFile();
				if (!file.exists()) {
					file.createNewFile();
				}
				// t@C
	            FileOutputStream fos = new FileOutputStream(file.getAbsolutePath());
	            PrintWriter out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(fos, "UTF-8")));
	            
	            // wb_̏
	            StringBuffer header = new StringBuffer();
	            int i = 0;
	            if (treeTableModel.isRemovedEmptyColumn()) {
		            for (String name : treeTableModel.getColumnNameList()) {
		            	if (i == 0) {
		            		header.append("\"" + name + "\"");
		            	} else {
		            		header.append(",\"" + name + "\"");
		            	}
		            	i++;
		            }
				} else {
		            for (String name : this.colNames) {
		            	if (i == 0) {
		            		header.append("\"" + name + "\"");
		            	} else {
		            		header.append(",\"" + name + "\"");
		            	}
		            	i++;
		            }
				}
	            out.println(header.toString());
	            
	            // s̏
	            for (ConceptTreeNode node : treeTableModel.getNodeList()) {
	            	// ẽ`FbNi}[WĂƖj
	            	if (node.getParent() != null && node.getParent().isMerged()) {
	            		continue;
	            	}
	            	
	            	// s̏
	            	String rowName = node.getConcept().getLabel();
	            	StringBuffer cellValue = new StringBuffer();
	            	if (treeTableModel.isRemovedEmptyColumn()) {
	            		int j = 0;
			            for (String colName : treeTableModel.getColumnNameList()) {
			            	if (j > 0) {		// Pڂ͔΂
				            	String key = rowName + ConceptTreeTableModel.E_A_DELIMITER + colName;
				            	String value = treeTableModel.getCellValue(key);
				            	if (value != null) {
				            		cellValue.append(",\"" + value + "\"");
				            	} else {
				            		cellValue.append(",\"" + ConceptTreeTableModel.BLANK_CHAR + "\"");
				            	}
			            	}
			            	j++;
			            }
	            	} else {
	            		int k = 0;
			            for (String value : node.getValueList()) {
			            	if (k > 0) {		// Pڂ͔΂
				            	if (value != null) {
				            		cellValue.append(",\"" + value + "\"");
				            	} else {
				            		cellValue.append(",\"\"");
				            	}
			            	}
			            	k++;
			            }
	            	}
	            	if (node.isMerged()) {
	            		out.println("\"" + rowName + ConceptTreeTableModel.MERAGED_LABEL + "\"" + cellValue.toString());
	            	} else {
	            		out.println("\"" + rowName + "\"" + cellValue.toString());
	            	}
	            }
	            
	            out.close();
	            fos.close();
	            
	            JOptionPane.showMessageDialog(this, "t@Co͂܂\n\"" + file.getName() + "\"", "mF", JOptionPane.INFORMATION_MESSAGE);
				
			} catch (Exception e) {
				if (e instanceof FileNotFoundException) {
					System.out.println("[Error]: " + e.getLocalizedMessage());
				} else {
					e.printStackTrace();
				}
				JOptionPane.showMessageDialog(this, "t@Co͂ł܂ł", "x", JOptionPane.WARNING_MESSAGE);
			}
		}
		
		// TO}[W܂B
		public void mergeConcept() {
    		ConceptTreeNode node = this.getSelectedTreeNode();
    		if (node != null) {	
    			int ret = JOptionPane.NO_OPTION;
    			// \TOIXg𐶐
    			List<String> strArray = new ArrayList<String>(node.getChildren().size());
    			for (ConceptTreeNode chiNode : node.getChildren()) {
    				if (chiNode != null) {
    					strArray.add(chiNode.getConcept().getLabel());
    				}
    			}
    			String[] items = (String[]) strArray.toArray(new String[0]);
    			JComboBox jCB_RepresentNodes = new JComboBox(items);
    			// mFbZ[W\
    			if (node.isMerged()) {
	    			Object[] mes = { "TO \"" + node.getConcept().getLabel() + "\" ̃}[W܂H" };
	    			String title = "}[W܂H";
	    			ret = JOptionPane.showConfirmDialog(this, mes, title, JOptionPane.YES_NO_OPTION, JOptionPane.INFORMATION_MESSAGE);	
    			} else {
    				Object[] mes = { "TO \"" + node.getConcept().getLabel() + "\" }[W܂H" , "\TOIF", jCB_RepresentNodes};
    				String title = "}[W܂H";
    				ret = JOptionPane.showConfirmDialog(this, mes, title, JOptionPane.YES_NO_OPTION, JOptionPane.INFORMATION_MESSAGE);	
    			}
    			// }[W
	    		if (ret == JOptionPane.YES_OPTION) {
	    			if (node.isMerged()) {
	    				// }[W
	    				node.setMerged(false);
	    			} else {
	    				int selIndex = jCB_RepresentNodes.getSelectedIndex();
	    				if (selIndex >= 0) {
	    					// \m[hw
	    					node.setRepresentNode(node.getChildren().get(selIndex));
	    					// }[W
	    					node.setMerged(true);
	    				}
	    			}
	    			// XgXV
	    			this.getTreeTableModel().getCellValueListMap().put(node.getConcept(), node.getValueList());
	    			// lXV
	    			String strE = node.getConcept().getLabel();
	    			int i = 0;
	    			for (String colName : colNames) {
	    				if (i > 0) {
	    					String key = strE + ConceptTreeTableModel.E_A_DELIMITER + colName;
	    					treeTableModel.putCellValue(key, node.getValueList().get(i));
	    				}
	    				i++;
	    			}
	    			
	    			// e[uXV
					treeTable.revalidate();
					treeTable.repaint();
	    		}
    		}
		}
		
		// l萫lɕϊ܂B
		public void convertValue() {
			int row = treeTable.getSelectedRow();
			int column = treeTable.getSelectedColumn();
			ConceptTreeNode selectedNode = this.getSelectedTreeNode();
			if (column < 0) {
				JOptionPane.showMessageDialog(this, "e[ũZIĂ܂", "bZ[W", JOptionPane.INFORMATION_MESSAGE);
				return;
			}
			String a = treeTableModel.getColumnName(column);
			String strValue = getCellValue(row, column);
			if (strValue != null && strValue.length() > 0) {
				try {
					// TO
					Concept attrCon = getConcept(ont, a);
					
					// l萫lɕϊ܂
					if (strValue.contains(ConceptTreeTableModel.VALUE_DELIMITER)) {
						String[] strValueArray = strValue.split(ConceptTreeTableModel.VALUE_DELIMITER);
						boolean isChecked = false;
						for (int i = 0; i < strValueArray.length; i++) {
							String tmpStrValue = strValueArray[i];
							String[] qualitiveValues = convertValue(attrCon, tmpStrValue);
							// 萫l΁AbZ[W\
							if (qualitiveValues != null && qualitiveValues.length > 0) {
								isChecked = true;
								JComboBox jCB_QualitativeValues = new JComboBox(qualitiveValues);
								Object[] mes = { "ʒl: \"" + tmpStrValue + "\" ", "萫l:", jCB_QualitativeValues, "ɕϊ܂H" };
								int ret = JOptionPane.showConfirmDialog(this, mes, "萫lɕϊ܂H", JOptionPane.YES_NO_OPTION, JOptionPane.INFORMATION_MESSAGE);
								// ʒl萫lɒu
								if (ret == JOptionPane.YES_OPTION) {
									String selecetedValue = jCB_QualitativeValues.getSelectedItem().toString();
									// ɂ΁idȂ悤Ɂj폜Ă
									String remevedValue = strValue.replace(ConceptTreeTableModel.VALUE_DELIMITER + selecetedValue, "");
									remevedValue = remevedValue.replace(selecetedValue, "");
									String newValue = remevedValue.replace(tmpStrValue, selecetedValue);
									if (newValue.lastIndexOf(ConceptTreeTableModel.VALUE_DELIMITER) == newValue.length() - 1) {
										newValue = newValue.substring(0, newValue.length() - 1);
									}
									putCellValue(row, column, newValue);
									treeTable.revalidate();
									treeTable.repaint();
								}
							}
						}
						if (!isChecked) {
							JOptionPane.showMessageDialog(this, "Y萫lȂׁAϊł܂łB", "bZ[W", JOptionPane.INFORMATION_MESSAGE);							
						}
					} else {
						String[] qualitiveValues = convertValue(attrCon, strValue);
						// 萫l΁AbZ[W\
						if (qualitiveValues != null && qualitiveValues.length > 0) {
							JComboBox jCB_QualitativeValues = new JComboBox(qualitiveValues);
							Object[] mes = { "ʒl: \"" + strValue + "\" ", "萫l:", jCB_QualitativeValues, "ɕϊ܂H" };
							int ret = JOptionPane.showConfirmDialog(this, mes, "萫lɕϊ܂H", JOptionPane.YES_NO_OPTION, JOptionPane.INFORMATION_MESSAGE);
							// ʒl萫lɒu
							if (ret == JOptionPane.YES_OPTION) {
								String selecetedValue = jCB_QualitativeValues.getSelectedItem().toString();
								putCellValue(row, column, selecetedValue);
								treeTable.revalidate();
								treeTable.repaint();
							}
						} else {
							JOptionPane.showMessageDialog(this, "Y萫lȂׁAϊł܂łB", "bZ[W", JOptionPane.INFORMATION_MESSAGE);
						}
					}
					
				} catch (Exception e) {
					if (e instanceof NumberFormatException) {
						JOptionPane.showMessageDialog(this, "ʒliljł͂ȂׁA萫lϊł܂łB", "bZ[W", JOptionPane.INFORMATION_MESSAGE);
						System.out.println("[Erorr]: ʒliljł͂܂");
					} else {
						e.printStackTrace();
					}
				}
			}
		}
		
		private String[] convertValue(Concept attrCon, String strValue) {
			List<String> rtnList = new ArrayList<String>();
			
			// ŏ̕`FbN
			if (strValue != null) {
				try {
					String firstStr = strValue.substring(0, 1);
					int chkVal = getIntValue(firstStr);
				} catch (Exception e) {
					return null;
				}
			} else {
				return null;
			}
			
			int intValue = getIntValue(strValue);	// l݂̂𒊏o
			
			// l̂l擾
			//String qualitiveValue = null;
			for (Slot refSlot : attrCon.getReferenceSlotList()) {
				//System.out.println("   +" + refSlot.getSlotPath());
				if (refSlot.isSlotOfSlot()) {
					Slot parRefSlot = refSlot.getParentSlot();
					String roleName = refSlot.getParentSlot().getRoleName();
					if (roleName.equals(LARGE)) {
						Slot upperThreshold = getSubSlotByRoleName(parRefSlot, UPPER_THRESHOLD);
						if (upperThreshold != null) {
							String thresholdValue = upperThreshold.getConstraintConceptLabel();
							int intThresholdValue = getIntValue(thresholdValue);
							if (intThresholdValue <= intValue) {
								//qualitiveValue = parRefSlot.getRoleHolderName();
								//break;
								rtnList.add(parRefSlot.getRoleHolderName());
							}
						}
					} else if (roleName.equals(MIDDLE)) {
						Slot upperThreshold = getSubSlotByRoleName(parRefSlot, UPPER_THRESHOLD);
						Slot lowerThreshold = getSubSlotByRoleName(parRefSlot, LOWER_THRESHOLD);
						if (upperThreshold != null && lowerThreshold != null) {
							String upperThresholdValue = upperThreshold.getConstraintConceptLabel();
							int intUpperThresholdValue = getIntValue(upperThresholdValue);
							String lowerThresholdValue = lowerThreshold.getConstraintConceptLabel();
							int intLowerThresholdValue = getIntValue(lowerThresholdValue);
							if (intUpperThresholdValue > intValue 
									&& intLowerThresholdValue <= intValue) {
								//qualitiveValue = parRefSlot.getRoleHolderName();
								//break;
								rtnList.add(parRefSlot.getRoleHolderName());
								
							}
						}
					} else if (roleName.equals(SMALL)) {
						Slot lowerThreshold = getSubSlotByRoleName(parRefSlot, LOWER_THRESHOLD);
						if (lowerThreshold != null) {
							String thresholdValue = lowerThreshold.getConstraintConceptLabel();
							int intThresholdValue = getIntValue(thresholdValue);
							if (intThresholdValue > intValue) {
								//qualitiveValue = parRefSlot.getRoleHolderName();
								//break;
								rtnList.add(parRefSlot.getRoleHolderName());
							}
						}	
					}
				}
			}
			return (String[]) rtnList.toArray(new String[0]);
		}
		
		// ̃[̃Xbg擾܂B
		private Slot getSubSlotByRoleName(Slot slot, String roleName) {
			List<Slot> tmpSlots = slot.findSlotsByRoleName(roleName);
			if (tmpSlots != null && !tmpSlots.isEmpty()) {
				return tmpSlots.get(0);
			}
			return null;
		}
		
		// 񂩂l擾܂B
		private int getIntValue(String strValue) {
			return Integer.parseInt(strValue.replaceAll("[^0-9]",""));
		}
		
		// Z̒l擾܂B
		public String getCellValue(int row, int column) {
			List<ConceptTreeNode> subNodes = treeTableModel.getNodeList();
			String e = (String) treeTableModel.getValueAt(subNodes.get(row), 0);
			String a = treeTableModel.getColumnName(column);
			String key = e + ConceptTreeTableModel.E_A_DELIMITER + a;
			String v = (String) treeTableModel.getCellValue(key);
			if (v == null) {
				v = ConceptTreeTableModel.BLANK_CHAR;
			}
			return v;
		}
		
		// Z̒lݒ肵܂B
		public void putCellValue(int row, int column, String value) {
			List<ConceptTreeNode> subNodes = treeTableModel.getNodeList();
			String e = (String) treeTableModel.getValueAt(subNodes.get(row), 0);
			String a = treeTableModel.getColumnName(column);
			String key = e + ConceptTreeTableModel.E_A_DELIMITER + a;
			String v = (String) treeTableModel.getCellValue(key);
			treeTableModel.putCellValue(key, value);
			// e[ufύXi`pj
			//treeTableModel.setValueAt(value, subNodes.get(row), column);
			treeTableModel.setValueAt(value, row, column);
			List<String> valueList = treeTableModel.getCellValueListMap().get(subNodes.get(row).getConcept());
			int colIndex = valueList.indexOf(v);
			if (colIndex >= 0) {
				valueList.set(colIndex, value);
				((ConceptTreeNode) subNodes.get(row)).getValueList().set(colIndex, value);
			}
		}
		
		// TO擾
		public Concept getConcept(Ontology ont, String label) {
			Concept rtrCon = ont.findWholeConceptByLabel(label);
			if (rtrCon == null) {
				rtrCon = ont.findConceptByLabel(label, RoleHolder.CONCEPT_TYPE);
			}
			return rtrCon;
		}
		
	}
	// End TreeTableFrame
	
	class TreeTablePopupMenu extends JPopupMenu {
		JMenuItem jMI_MergeValue;
		// RXgN^
		TreeTablePopupMenu(final JFrame frame) {
		    jMI_MergeValue = new JMenuItem("merge Concepts ...");
		    jMI_MergeValue.addActionListener(new ActionListener() {
		    	public void actionPerformed(ActionEvent e) {
		    		((TreeTableFrame) frame).mergeConcept();
		    	}
		    });
		    add(jMI_MergeValue);
		}
		protected void updateMenu(ConceptTreeNode node) {
			if (node != null && node.isMerged()) {
				jMI_MergeValue.setText("unmerge Concepts ...");
			} else {
				jMI_MergeValue.setText("merge Concepts ...");
			}
		}
	}
	// End TreeTablePopupMenu
	
	class TableColumnPopupMenu extends JPopupMenu {
		JMenuItem jMI_ConvertValue;
		// RXgN^
		TableColumnPopupMenu(final JFrame frame) {
			jMI_ConvertValue = new JMenuItem("convert value into qualitative quantity ...");
			jMI_ConvertValue.addActionListener(new ActionListener() {
		    	public void actionPerformed(ActionEvent e) {
		    		((TreeTableFrame) frame).convertValue();
		    	}
		    });
		    add(jMI_ConvertValue);
		}
	}
	// End TreeTablePopupMenu
	
	class TreeTableMenuBar extends JMenuBar {
		
		JMenuItem jMI_MergeValue;
		JMenuItem jMI_ConvertValue;
		
		TreeTableMenuBar(final JFrame frame) {
		    JMenu jM_File = new JMenu("File");
		    // ۑ
		    JMenuItem jMI_Save = new JMenuItem("export Table ...");
		    jMI_Save.addActionListener(new ActionListener() {
		    	public void actionPerformed(ActionEvent e) {
		    		((TreeTableFrame) frame).exportTable();
		    	}
		    });
		    jM_File.add(jMI_Save);
		    add(jM_File);
		    
		    JMenu jM_Edit = new JMenu("Edit");
		    // }[W
		    jMI_MergeValue = new JMenuItem("merge Concepts ...");
		    jMI_MergeValue.addActionListener(new ActionListener() {
		    	public void actionPerformed(ActionEvent e) {
		    		((TreeTableFrame) frame).mergeConcept();
		    	}
		    });
		    jM_Edit.add(jMI_MergeValue);
		    jM_Edit.addSeparator();
		    
		    // 萫lϊ
		    jMI_ConvertValue = new JMenuItem("convert value into qualitative quantity ...");
		    jMI_ConvertValue.addActionListener(new ActionListener() {
		    	public void actionPerformed(ActionEvent e) {
		    		((TreeTableFrame) frame).convertValue();
		    	}
		    });
		    jM_Edit.add(jMI_ConvertValue);
		    jM_Edit.addSeparator();
		    
		    // e[uݒ
		    JMenuItem jMI_Preference = new JMenuItem("settings ...");
		    jMI_Preference.addActionListener(new ActionListener() {
		    	public void actionPerformed(ActionEvent e) {
		    		setTreeTableConf();
		    	}
		    });
		    jM_Edit.add(jMI_Preference);
		    add(jM_Edit);
		    
		    JMenu jM_View = new JMenu("View");
		    // ^f[^\
		    JMenuItem jMI_DisplayMetadata = new JMenuItem("Metadata view ...");
		    jMI_DisplayMetadata.addActionListener(new ActionListener() {
		    	public void actionPerformed(ActionEvent e) {
            		createMetadataTable();
		    	}
		    });
		    jM_View.add(jMI_DisplayMetadata);
		    add(jM_View);
		}
		
		protected void updateMenu(ConceptTreeNode node) {
			if (node != null && node.isMerged()) {
				jMI_MergeValue.setText("unmerge Concepts ...");
			} else {
				jMI_MergeValue.setText("merge Concepts ...");
			}
		}
	}
	// End TreeTableMenuBar
	
	/**
	 * c[e[u\
	 * 
	 */
	class MetadataTableFrame extends TreeTableFrame {
		// RXgN^
		MetadataTableFrame(boolean isShortCut, boolean isValueMasked) {
			this(isShortCut, isValueMasked, -1);
		}
		MetadataTableFrame(boolean isShortCut, boolean isValueMasked, int columnWidth) {
			this(isShortCut, isValueMasked, columnWidth, false, false);
		}
		MetadataTableFrame(boolean isShortCut, boolean isValueMasked, int columnWidth, boolean replaceLineToColumn, boolean removeEmptyColumn) {
			super(isShortCut, isValueMasked, columnWidth, replaceLineToColumn, removeEmptyColumn);
			
		    // e[uɕ\f[^
		    if (isReplacedLineToColumn) {
		    	treeTableModel = new MetadataTableModel(attributeConcept, ont, getColumnNames(), entityConcept, valueConcept, eavRepresentConcept, isValueMasked, isReplacedLineToColumn, isRemovedEmptyColumn);
		    } else {
		    	treeTableModel = new MetadataTableModel(entityConcept, ont, getColumnNames(), attributeConcept, valueConcept, eavRepresentConcept, isValueMasked, isReplacedLineToColumn, isRemovedEmptyColumn);
		    }
		    
		    // Jݒ
		    treeTableModel.setColumnNames(getColumnNames());

		    // c[e[u
			treeTable = new JXTreeTable(treeTableModel) {
				/**
				 * 
				 */
				private static final long serialVersionUID = 151L;

				protected JTableHeader createDefaultTableHeader() {
					return new GroupableTableHeader(columnModel);
				}
			};

			super.colCnt = 1;
		    TableColumnModel tableColumnModel = treeTable.getColumnModel();
		    ColumnGroup colGroup = createColumnGroup(columnz, tableColumnModel);
		    if (colGroup != null) {
			    GroupableTableHeader header = (GroupableTableHeader) treeTable.getTableHeader();
			    header.addColumnGroup(colGroup);
			    header.addMouseListener(new MouseAdapter() {
					@Override
					public void mouseClicked(MouseEvent me) {
						// _uNbN̏ꍇ
						if (me.getClickCount() > 1) {

						}
					}
			    });
		    }
		    // ׂĊJ
		    treeTable.expandAll();
	    
			treeTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			treeTable.setColumnSelectionAllowed(true);
			treeTable.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseClicked(MouseEvent me) {
					Point pt = me.getPoint();
					int idx = treeTable.rowAtPoint(pt);
					int idy = treeTable.columnAtPoint(pt);
					//System.out.println("[" + idx + ", " + idy + "]");
					if (idx >= 0 && idy >= 0) {
						int row = treeTable.convertRowIndexToModel(idx);
						int col = treeTable.convertColumnIndexToModel(idy);
						
						List<ConceptTreeNode> subNodes = treeTableModel.getNodeList();
						String e = (String) treeTableModel.getValueAt(subNodes.get(row), 0);
						ConceptTreeNode selectedNode = (ConceptTreeNode) treeTable.getPathForRow(row).getLastPathComponent();
						setSelectedTreeNode(selectedNode);
						if (selectedNode != null) {
							e = selectedNode.getConcept().getLabel();
						}
						String a = treeTableModel.getColumnName(idy);
						String v = (String) treeTableModel.getValueAt(row, col);
						List<String> valueList = ((MetadataTableModel) treeTableModel).getSlotValueListMap().get(e);
						if (valueList != null) {
							v = valueList.get(col);
						}
						if (idy > 0) {
							updateStatusLabel(e, a, v);
							// _uNbN̏ꍇ
							if (me.getClickCount() > 1 && !v.equals(ConceptTreeTableModel.BLANK_CHAR)) {
								Concept con = getConcept(a);
								if (con instanceof RoleHolder) {
									Slot depSlot = ((RoleHolder) con).getDependentSlot();
									if (depSlot != null) {
										Concept tmpCon = depSlot.getOwnerConcept();
										List<Slot> tmpSlots = depSlot.findSlotsByRoleName(e); 	
										if (tmpSlots != null && !tmpSlots.isEmpty()) {
											paintGraphPanel(tmpCon, tmpSlots.get(0));
										} else {
											paintGraphPanel(tmpCon, depSlot);
										}
										ontTree.selectConceptNode(tmpCon); 
									}
								} else {
									List<Slot> tmpSlots = con.findSlotsByRoleName(e); 	
									if (tmpSlots != null && !tmpSlots.isEmpty()) {
										paintGraphPanel(con, tmpSlots.get(0));
									} else {
										paintGraphPanel(con);
									}
									ontTree.selectConceptNode(con);
								}
							}
						}
						else if (idy == 0) {
							// _uNbN̏ꍇ
							if (me.getClickCount() > 1) {
								if (selectedNode != null) {
									if (selectedNode instanceof SlotTreeNode) {
										Slot selSlot = ((SlotTreeNode) selectedNode).getSlot();
										Concept selCon = selSlot.getOwnerConcept();
										paintGraphPanel(selCon, selSlot);
										ontTree.selectConceptNode(selCon);
									} else {
										Concept selCon = selectedNode.getConcept();
										paintGraphPanel(selCon);
										ontTree.selectConceptNode(selCon);
									}
								}
							}
						}
					}
				}
			});
			treeTable.addTreeSelectionListener(new TreeSelectionListener() {
				public void valueChanged(TreeSelectionEvent e) {
					
				}
			});
			
//			treeTable.setDefaultRenderer(Object.class, new ConceptTreeTableCellRenderer());
//			treeTable.setTreeCellRenderer(new TableConceptTreeCellRenderer());
			DefaultTableColumnModel cmodel = (DefaultTableColumnModel) treeTable.getColumnModel();
			Enumeration<TableColumn> en = cmodel.getColumns();
			while (en.hasMoreElements()) {
				TableColumn column = (TableColumn) en.nextElement();
				column.setCellRenderer(new ConceptTreeTableCellRenderer());
			}
			
			// ŏ̃JŒ肷
			tableColumnModel.getColumn(0).setPreferredWidth(250);
			// J폜
			if (isRemovedEmptyColumn) {
				removeEmptyColumns();
			}
			// lXV
			((MetadataTableModel) treeTableModel).setMetadataValue();

			JScrollPane scrollPane = new JScrollPane(treeTable, 
								    		JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
								    		JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		    scrollPane.setAutoscrolls(true);		    
		    		    
//		    tableMenuBar = new TreeTableMenuBar(this);
//		    setJMenuBar(tableMenuBar);
		    
			statusLabel = createStatusLabel();
		    
		    getContentPane().add(scrollPane, BorderLayout.CENTER);
		    getContentPane().add(statusLabel, BorderLayout.SOUTH);
		    
			this.setTitle("Metadata Table");
			this.setBounds(300, 320, 800, 500);
		}
		
		private Concept getConcept(String label) {
			Concept rtrCon = ont.findWholeConceptByLabel(label);
			if (rtrCon == null) {
				rtrCon = ont.findConceptByLabel(label, RoleHolder.CONCEPT_TYPE);
			}
			return rtrCon;
		}
	}
	// End MetadataTableFrame
}
